﻿function MediaControlAssistant() 
{
}

MediaControlAssistant.prototype.setup = function()
{
	console.log("MediaControlAssistant.prototype.setup");
	//-----------------------------------------------------------------------------
	//---------------------init--debugMode--trace------------------------------
	//-----------------------------------------------------------------------------
	spark.globalUIObject.debugMode=true;
	this.trace = viewUtil.trace;
	this.trace("init Scene");

	//-------------------------------------------------------------------------------------------
	//---------Callback----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.sysResponseCallback = function(response){
		this.trace(response.curCmd + " / " + response.status);
	}.bind(this)
	
	/*----------------------------------------------
	* mark when testing UI
	-----------------------------------------------*/
	spark.globalUIObject.currentService.setResponseCallback(this.sysResponseCallback);
	
	//-------------------------------------------------------------------------------------------
	//---------TabBar----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.divArray = [
	{
		"id": "mediaDiv",
		"name": L('Play Control'),
		"listItem": "tabPlay",
		"skin": "tabPlay",
		"skinH": "tabPlayH",
		"tabSelectedClass":"tabSelectedImage1",
		"tabX":"-10px"
	}, 
	{
		"id": "gestureDiv",
		"name": L('Mouse Pad'),
		"listItem": "tabGes",
		"skin": "tabGes",
		"skinH": "tabGesH",
		"tabSelectedClass":"tabSelectedImage2",
		"tabX":"200px"
	}, 
	{
		"id": "navDiv",
		"name": "DVD/BD",
		"listItem": "tabNav",
		"skin": "tabNav",
		"skinH": "tabNavH",
		"tabSelectedClass":"tabSelectedImage1",
		"tabX":"-10px"
	}];

	this.tabFunctions = 
	{
		tabBarClicked: function(e)
		{
			var data = $A(arguments);
			data.shift();
			var newDivIndex = data[0];
			
			if (this.divIndex != newDivIndex) 
			{
				$('titleDiv').innerHTML = this.divArray[newDivIndex].name;
				$('tabSelectedImage').className = this.divArray[newDivIndex].tabSelectedClass;

				this.redraw = function()
				{
					console.log("[PDVD Remote] effect finished");
				}

				var strCurrentPageName = this.divArray[this.divIndex].id;
				var strNextPageName = this.divArray[newDivIndex].id;
				$(strCurrentPageName).style.display = 'none';
				$(strNextPageName).style.display = '';
				// this.oldIndex = this.divIndex;
				// this.AnimationDuration = 0.5;
				// if(0 == newDivIndex && 2 == this.oldIndex)
				// { 				
					// new Effect.SlideUp(this.divArray[this.divIndex].id, {
						// duration: this.AnimationDuration,
						// afterFinish : this.redraw.bind(this)
					// });
				// }
				// else 
				// {
					// new Effect.Fade(this.divArray[this.divIndex].id, {
						// duration: this.AnimationDuration
					// });
				// }

				// if (2 == newDivIndex)
				// {
					// new Effect.SlideDown(this.divArray[newDivIndex].id, {
						// duration: this.AnimationDuration,
						// afterFinish : this.redraw.bind(this)
					// });
				// }
				// else
				// {
					// new Effect.Appear(this.divArray[newDivIndex].id, {
						// duration: this.AnimationDuration,
						// afterFinish : this.redraw.bind(this)
					// });
				// }

				/*----------------------------------------------
				------------------------------------------------
				* work around
				* why : renderer error when Effect Appear finished
				* how : animation the bodyDiv to force redraw
				------------------------------------------------
				-----------------------------------------------*/
				// new Effect.Opacity('bodyDiv', {
					// to: 0.9,
					// duration: 0.01,
					// queue: 'end' 
				// });
				// new Effect.Appear($('bodyDiv'), {
					// queue: 'end',
					// duration: 0.01
				// });

				this.divIndex = newDivIndex;
			}
		}
	}

	Event.observe($("anchorPlay"), viewUtil.clickEventName(),this.tabFunctions.tabBarClicked.bindAsEventListener(this, 0));
	Event.observe($("anchorGes"), viewUtil.clickEventName(), this.tabFunctions.tabBarClicked.bindAsEventListener(this, 1));

	//-------------------------------------------------------------------------------------------
	//---------BackBtn----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	

	this.backBtnPressed = function(e)
	{
		$("mediaControl-backBtn").style.opacity=0.5;
	}.bind(this)
	
	this.backBtnReleased = function(e)
	{
		$("mediaControl-backBtn").style.opacity=1;
		huf.navigator.popView();
	}.bind(this)
	
	Event.observe($("mediaControl-backBtn"), viewUtil.clickEventName(), this.backBtnPressed);
	Event.observe($("mediaControl-backBtn"), viewUtil.clickUpEventName(), this.backBtnReleased);
	
	//-------------------------------------------------------------------------------------------
	//---------touch----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	
	var captured = false;
	var Scrollcaptured = false;
	var bIsDragAndDrop = false;
	this.originalPoint = 
	{
		x: 0,
		y: 0
	};
	this.isEventPoped = false;
	
	this.getRealPoint = function(e)
	{
		if (e.pageX) 
		{
			return {
				/*---------------------
				 * webos
				 ---------------------*/
				"x": e.pageX,
				"y": e.pageY
			}
		}
		else 
		{
			return {
				/*----------------------
				 * android
				 ----------------------*/
				"x": e.touches[0].pageX,
				"y": e.touches[0].pageY
			}
		}
	}
	
	this.sendRClick = false;
	this.sendMouseRClick = function()
	{
		console.log("[Remote2.0] sendMouseRClick");
		var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_RIGHTDOWN | huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_MOVE;
		spark.globalUIObject.currentService.sendMouseEvent(0, 0, dwFlags);
		
		var dwFlags2 = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_RIGHTUP | huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_MOVE;
		spark.globalUIObject.currentService.sendMouseEvent(0, 0, dwFlags2);
		
		this.sendRClick = true;
		clearTimeout(this.discoveryTimer);
	}
	
	this.setRightKeyTimer = function()
	{
		console.log("[Remote] setRightKeyTimer");
		if (this.enableRightKeyTimer == true) {
			// avoid duplicated setTimeout
			this.resetRightKeyTimer();
		};
		this.enableRightKeyTimer = true;
		this.discoveryTimer = window.setTimeout(function()
		{
			console.log("setTimeout for sendMouseRClick");
			this.sendMouseRClick();
		}.bind(this), 1000);
	}
	this.resetRightKeyTimer = function()
	{
		if (this.enableRightKeyTimer == true)
		{
			console.log("[Remote] resetRightKeyTimer");
			clearTimeout(this.discoveryTimer);
			this.enableRightKeyTimer = false;
		}
	}
	
	this.mousedownHandler = function(e)
	{
		/*------------------------------------------------------------------------------
	 	* work around
	 	* http://code.google.com/p/android/issues/detail?id=5491
	 	* prevent android system take over the move event
	 	------------------------------------------------------------------------------*/
		viewUtil.preventDefault(e);
		
		if (Scrollcaptured)
		{
			return ;
		}
		
		this.setRightKeyTimer();
		
		$("watermark").style.display = 'none';
		var realPoint = this.getRealPoint(e);
		this.originalPoint = 
		{
			x: realPoint.x,
			y: realPoint.y
		};
		captured = true;
		this.isEventPoped = false;
		this.isMouseMove = false;
	}.bind(this)
	
	this.mouseupHandler = function(e)
	{
		this.resetRightKeyTimer();
		if (this.sendRClick == true)
		{
			console.log("[Mouse] clearTimeout");
			this.sendRClick = false;
			return;
		}
		
		$("watermark").style.display = '';
		if (this.isEventPoped == false && this.isMouseMove == false) 
		{
			this.trace("mouse clicked");
			var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_LEFTDOWN | huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_MOVE;
			spark.globalUIObject.currentService.sendMouseEvent(0, 0, dwFlags);
			
			var dwFlags2 = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_LEFTUP | huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_MOVE;
			spark.globalUIObject.currentService.sendMouseEvent(0, 0, dwFlags2);
		}
		captured = false;
	}.bind(this)

	this.mousemoveHandler = function(e)
	{
		if (Scrollcaptured)
		{
			return ;
		}

		this.resetRightKeyTimer();
		
		if (captured && this.isEventPoped == false) 
		{
			this.isMouseMove = true;
			var realPoint = this.getRealPoint(e);
			
			var diffPoint = 
			{
				x: realPoint.x - this.originalPoint.x,
				y: realPoint.y - this.originalPoint.y
			};
			
			this.trace(realPoint.x + "," + realPoint.y);
			
			var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_MOVE;
			
			spark.globalUIObject.currentService.sendMouseEvent(diffPoint.x*2, diffPoint.y, dwFlags);
			
			this.originalPoint.x = realPoint.x;
			this.originalPoint.y = realPoint.y;
		}
	}.bind(this)
	
	this.regTouchFunctions = viewUtil.regTouchFunctions;
	this.regTouchFunctions();
	
	this.ScrolldownHandler = function(e)
	{
		/*------------------------------------------------------------------------------
	 	* work around
	 	* http://code.google.com/p/android/issues/detail?id=5491
	 	* prevent android system take over the move event
	 	------------------------------------------------------------------------------*/
		viewUtil.preventDefault(e);
		
		/*$("watermark").style.display = 'none';*/
		$("scrollbar").style.display = 'none';
		$("scrollbarFocus").style.display = '';
		//$("scrollbar").src =  "../Resource/images/gesture/scrollbar_p.png"
		var realPoint = this.getRealPoint(e);
		this.originalScrollPoint = 
		{
			x: realPoint.x,
			y: realPoint.y
		};
		Scrollcaptured = true;
		this.isEventPoped = false;
		this.isMouseMove = false;
	}.bind(this)
	
	this.ScrollupHandler = function(e)
	{
		$("scrollbar").style.display = '';
		$("scrollbarFocus").style.display = 'none';
		//$("scrollbar").src =  "../Resource/images/gesture/scrollbar.png"
		Scrollcaptured = false;
	}.bind(this)
	
	this.ScrollMoveHandler = function(e)
	{
		if (Scrollcaptured && this.isEventPoped == false) 
		{
			this.isMouseMove = true;
			var realPoint = this.getRealPoint(e);
			
			var diffPoint = {
				x: realPoint.x - this.originalScrollPoint.x,
				y: realPoint.y - this.originalScrollPoint.y
			};
			
			this.trace(realPoint.x + "," + realPoint.y);
			
			if (diffPoint.y>0)
			{
				spark.globalUIObject.currentService.sendMouseWheelEvent(-120);
			}
			else 
			{
				spark.globalUIObject.currentService.sendMouseWheelEvent(120);
			}
			
			this.originalScrollPoint.x = realPoint.x;
			this.originalScrollPoint.y = realPoint.y;
		}
	}.bind(this)
	Event.observe($('scrollbar'), 'touchstart', this.ScrolldownHandler);
	Event.observe($('scrollbar'), 'touchend', this.ScrollupHandler);
	Event.observe($('scrollbar'), 'touchmove', this.ScrollMoveHandler);
	
	//-------------------------------------------------------------------------------------------
	//---------gesture----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	
	this.gestureFunctions = 
	{
		gesturestartHandler: function(e)
		{
			console.log("gesturestartHandler e.scale : " + e.LParam + "e.rotation" + e.RParam);
			this.isEventPoped = true;
		},
		
		gesturechangeHandler: function(e)
		{
			console.log("[PDVD Remote]: gesturechangeHandler");
			this.isMouseMove = true;
			
			this.isEventPoped = false;
			captured = true;
			if (false == bIsDragAndDrop)
			{
				spark.globalUIObject.currentService.sendLButtonDownEvent();
				bIsDragAndDrop = true;
			}
		},
		
		gestureendHandler: function(e)
		{
			console.log("[PDVDRemote] e.scale : " + e.LParam + ", e.rotation" + e.RParam);
			this.isEventPoped = true;
			
			if (1 != this.divIndex)
			{
				return;
			}
			
			var scale = e.LParam;
			var rotation = e.RParam;
			var scaleOffset = 0;
			if (scale >= 1) 
			{
				scaleOffset = scale - 1;
			}
			else 
			{
				scaleOffset = 1 - scale;
			}
			
			var rotateOffset = 0;
			if (isNaN(rotation)) 
			{
				rotateOffset = 0;
			}
			else
			{
				if (rotation >= 0) 
				{
					rotateOffset = rotation / 45;
				}
				else 
				{
					rotateOffset = 0 - (rotation / 45);
				}
			}
			console.log("[PDVDRemote] scaleOffset " + scaleOffset + ", rotateOffset" + rotateOffset);
			
			if (scaleOffset > 0.3) // Threshold for zoom in/out 
			{
				if (scale >= 1) 
				{
					this.trace("scaleUp");
					spark.globalUIObject.currentService.zoomIn();
				}
				else 
				{
					this.trace("scaleDown");
					spark.globalUIObject.currentService.zoomOut();
				}
				this.resetRightKeyTimer();
			}
			else if (rotation > 20 || rotation < -20) // Threshold in degree for rotate 
			{
				if (rotation >= 0) 
				{
					this.trace("---rotate right");
					spark.globalUIObject.currentService.rotateRight();
				}
				else 
				{
					this.trace("---rotate left");
					spark.globalUIObject.currentService.rotateLeft();
				}
				this.resetRightKeyTimer();
			}
			
			// workarround, we would not receive mouse up event when we do gesture
			$("watermark").style.display = '';
			spark.globalUIObject.currentService.sendLButtonUpEvent();
			bIsDragAndDrop = false;
		}
		
	}
	
	huf.gesture.observe("gestureDiv", "gesturestart", this.gestureFunctions.gesturestartHandler.bindAsEventListener(this));
	huf.gesture.observe("gestureDiv", "gesturechange", this.gestureFunctions.gesturechangeHandler.bindAsEventListener(this));
	huf.gesture.observe("gestureDiv", "gestureend", this.gestureFunctions.gestureendHandler.bindAsEventListener(this));
	
	//-------------------------------------------------------------------------------------------
	//---------Navigation buttons----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.navFunctions = 
	{
		navBtnClicked: function(e)
		{
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			this.trace(oper);
			switch (oper) 
			{
				case "arrowLeft":
					spark.globalUIObject.currentService.arrowLeft();
					$("navCrossBtn").style.display = 'none';
					$("navCrossBtnLeftFocus").style.display = '';
					break;
				case "arrowRight":
					spark.globalUIObject.currentService.arrowRight();
					$("navCrossBtn").style.display = 'none';
					$("navCrossBtnRightFocus").style.display = '';
					break;
				case "arrowUp":
					spark.globalUIObject.currentService.arrowUp();
					$("navCrossBtn").style.display = 'none';
					$("navCrossBtnUpFocus").style.display = '';
					break;
				case "arrowDown":
					spark.globalUIObject.currentService.arrowDown();
					$("navCrossBtn").style.display = 'none';
					$("navCrossBtnDownFocus").style.display = '';
					break;
				case "enter":
					spark.globalUIObject.currentService.enter();
					$("navCrossBtn").style.display = 'none';
					$("navCrossBtnEnterFocus").style.display = '';
					break;
				case "subtitle":
					$("navSubtitleBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.subtitle();
					break;
				case "menu":
					$("navMenuBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.menu();
					break;
				case "language":
					$("navLanguageBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.language();
					break;
				case "red":
					$("navRedBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.red();
					break;
				case "green":
					$("navGreenBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.green();
					break;
				case "blue":
					$("navBlueBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.blue();
					break;
				case "yellow":
					$("navYellowBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.yellow();
					break;
				case "fanview":
					$("navFanViewBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.fanview();
					break;
				case "previous":
					$("navPreBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.previous();
					break;
				case "next":
					$("navNextBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.next();
					break;
				case "rewind":
					$("navPlaybackControl").style.display = 'none';
					$("navPlaybackControlRewind").style.display = '';
					spark.globalUIObject.currentService.rewind();
					break;
				case "forward":
					$("navPlaybackControl").style.display = 'none';
					$("navPlaybackControlFastforward").style.display = '';
					spark.globalUIObject.currentService.forward();
					break;
				case "play":
					$("navPlaybackControl").style.display = 'none';
					$("navPlaybackControlPlay").style.display = '';
					spark.globalUIObject.currentService.play();
					break;
			}
			e.preventDefault();
		},
		navBtnReleaseed: function(e)
		{
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			this.trace(oper);
			switch (oper) 
			{
				case "arrowLeft":
					$("navCrossBtn").style.display = '';
					$("navCrossBtnLeftFocus").style.display = 'none';
					break;
				case "arrowRight":
					$("navCrossBtn").style.display = '';
					$("navCrossBtnRightFocus").style.display = 'none';
					break;
				case "arrowUp":
					$("navCrossBtn").style.display = '';
					$("navCrossBtnUpFocus").style.display = 'none';
					break;
				case "arrowDown":
					$("navCrossBtn").style.display = '';
					$("navCrossBtnDownFocus").style.display = 'none';
					break;
				case "enter":
					$("navCrossBtn").style.display = '';
					$("navCrossBtnEnterFocus").style.display = 'none';
					break;
				case "subtitle":
					$("navSubtitleBtn").style.opacity=1;
					break;
				case "menu":
					$("navMenuBtn").style.opacity=1;
					break;
				case "language":
					$("navLanguageBtn").style.opacity=1;
					break;
				case "red":
					$("navRedBtn").style.opacity=1;
					break;
				case "green":
					$("navGreenBtn").style.opacity=1;
					break;
				case "blue":
					$("navBlueBtn").style.opacity=1;
					break;
				case "yellow":
					$("navYellowBtn").style.opacity=1;
					break;
				case "fanview":
					$("navFanViewBtn").style.opacity=1;
					break;
				case "previous":
					$("navPreBtn").style.opacity=1;
					break;
				case "next":
					$("navNextBtn").style.opacity=1;
					break;
				case "rewind":
					$("navPlaybackControl").style.display = '';
					$("navPlaybackControlRewind").style.display = 'none';
					break;
				case "forward":
					$("navPlaybackControl").style.display = '';
					$("navPlaybackControlFastforward").style.display = 'none';
					break;
				case "play":
					$("navPlaybackControl").style.display = '';
					$("navPlaybackControlPlay").style.display = 'none';
					break;
			}
			e.preventDefault();
		}
	}
	
	Event.observe($("navLeftBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'arrowLeft'));
	Event.observe($("navRightBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'arrowRight'));
	Event.observe($("navUpBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'arrowUp'));
	Event.observe($("navDownBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'arrowDown'));
	Event.observe($("navOKBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'enter'));
	
	Event.observe($("navLeftBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'arrowLeft'));
	Event.observe($("navRightBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'arrowRight'));
	Event.observe($("navUpBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'arrowUp'));
	Event.observe($("navDownBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'arrowDown'));
	Event.observe($("navOKBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'enter'));
	
	Event.observe($("navSubtitleBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'subtitle'));
	Event.observe($("navMenuBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'menu'));
	Event.observe($("navLanguageBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'language'));
	Event.observe($("navFanViewBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'fanview'));
	
	Event.observe($("navSubtitleBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'subtitle'));
	Event.observe($("navMenuBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'menu'));
	Event.observe($("navLanguageBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'language'));
	Event.observe($("navFanViewBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'fanview'));
	
	Event.observe($("navRedBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'red'));
	Event.observe($("navGreenBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'green'));
	Event.observe($("navBlueBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked.bindAsEventListener(this, 'blue'));
	Event.observe($("navYellowBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'yellow'));
	
	Event.observe($("navRedBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'red'));
	Event.observe($("navGreenBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'green'));
	Event.observe($("navBlueBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'blue'));
	Event.observe($("navYellowBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'yellow'));
	
	Event.observe($("navTrayBtn"), viewUtil.clickEventName(),this.tabFunctions.tabBarClicked.bindAsEventListener(this, 0));
	
	Event.observe($("navPreBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'previous'));
	Event.observe($("navNextBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'next'));
	
	Event.observe($("navPreBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'previous'));
	Event.observe($("navNextBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'next'));
	
	Event.observe($("navRewindBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'rewind'));
	Event.observe($("navForwardBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'forward'));
	Event.observe($("navPlayBtn"), viewUtil.clickEventName(),this.navFunctions.navBtnClicked.bindAsEventListener(this, 'play'));
	
	Event.observe($("navRewindBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'rewind'));
	Event.observe($("navForwardBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'forward'));
	Event.observe($("navPlayBtn"), viewUtil.clickUpEventName(),this.navFunctions.navBtnReleaseed.bindAsEventListener(this, 'play'));
	
	//-------------------------------------------------------------------------------------------
	//---------Media buttons----------------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.mediaFunctions = 
	{
		mediaBtnClicked: function(e)
		{
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			this.trace(oper);
			switch (oper) {
				case "play":
					spark.globalUIObject.currentService.play();
					$("playbackControl").style.display = 'none';
					$("playbackControlPlayPressed").style.display = '';
					break;
				case "stop":
					$("stopBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.stop();
					break;
				case "next":
					$("nextBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.next();
					break;
				case "previous":
					$("preBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.previous();
					break;
				case "forward":
					spark.globalUIObject.currentService.forward();
					$("playbackControl").style.display = 'none';
					$("playbackControlForwardPressed").style.display = '';
					break;
				case "rewind":
					spark.globalUIObject.currentService.rewind();
					$("playbackControl").style.display = 'none';
					$("playbackControlRewindPressed").style.display = '';
					break;
				case "volumeUp":
					$("volumeUpBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.volumeUp();
					break;
				case "volumeDown":
					$("volumeDownBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.volumeDown();
					break;
				case "mute":
					$("muteBtn").style.opacity=0.5;
					spark.globalUIObject.currentService.mute();
					break;
			}
			e.preventDefault();
		},
		mediaBtnRelease: function(e)
		{
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			this.trace(oper);
			switch (oper) 
			{
				case "play":
					$("playbackControlPlayPressed").style.display = 'none';
					$("playbackControl").style.display = '';
					break;
				case "stop":
					$("stopBtn").style.opacity=1;
					break;
				case "next":
					$("nextBtn").style.opacity=1;
					break;
				case "previous":
					$("preBtn").style.opacity=1;
					break;
				case "forward":
					$("playbackControlForwardPressed").style.display = 'none';
					$("playbackControl").style.display = '';
					break;
				case "rewind":
					$("playbackControlRewindPressed").style.display = 'none';
					$("playbackControl").style.display = '';
					break;
				case "volumeUp":
					$("volumeUpBtn").style.opacity=1;
					break;
				case "volumeDown":
					$("volumeDownBtn").style.opacity=1;
					break;
				case "mute":
					$("muteBtn").style.opacity=1;
					break;
			}
			e.preventDefault();
		}
	}
	
	Event.observe($("trayBtn"), viewUtil.clickEventName(), this.tabFunctions.tabBarClicked.bindAsEventListener(this, 2));
	Event.observe($("preBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'previous'));
	Event.observe($("nextBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'next'));
	Event.observe($("volumeUpBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'volumeUp'));
	Event.observe($("volumeDownBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'volumeDown'));
	Event.observe($("playBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'play'));
	Event.observe($("stopBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'stop'));
	
	Event.observe($("rewindBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'rewind'));
	Event.observe($("forwardBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'forward'));
	Event.observe($("muteBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked.bindAsEventListener(this, 'mute'));
	
	Event.observe($("preBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'previous'));
	Event.observe($("nextBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'next'));
	Event.observe($("volumeUpBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'volumeUp'));
	Event.observe($("volumeDownBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'volumeDown'));
	Event.observe($("playBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'play'));
	Event.observe($("stopBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'stop'));
	
	Event.observe($("rewindBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'rewind'));
	Event.observe($("forwardBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'forward'));
	Event.observe($("muteBtn"), viewUtil.clickUpEventName(), this.mediaFunctions.mediaBtnRelease.bindAsEventListener(this, 'mute'));
	
	
	/* initiallize display div page */
	var currentModule = (spark.globalUIObject.apiVersion==1.0)
					 ? spark.globalUIObject.moduleArray[spark.globalUIObject.currentService.moduleIndex]
					 : spark.globalUIObject.controlInfo.supportFeature[spark.globalUIObject.currentService.moduleIndex];
					 
	if (currentModule == 'Movie'){
		// if selected module is 'Movie', show media div
		$("gestureDiv").style.display = "none"; 
		$("mediaDiv").style.display = "inherit"; 
		$("navDiv").style.display = "none"; 
		this.divIndex = 0;
	}
	else{
		// default, show gesture div
		$("gestureDiv").style.display = "inherit"; 
		$("mediaDiv").style.display = "none"; 
		$("navDiv").style.display = "none";
		this.divIndex = 1;
	}
	if (spark.globalUIObject.apiVersion == 1.0) {
		$("keyboardBtn").style.display = "none";
	};
	
	$('titleDiv').innerHTML = this.divArray[this.divIndex].name
	$('tabSelectedImage').className = this.divArray[this.divIndex].tabSelectedClass;

	/* * * * * * * * * * * * * * * * * * * * * * *
     * virtualKeyboard
     * * * * * * * * * * * * * * * * * * * * * * */
	this.sendBtnClicked = function(value) {
        console.log("sendBtnClicked : " + value);
		spark.globalUIObject.currentService.sendKeyboardText(value);
    };
    this.quitBtnClicked = function(value) {
	huf.navigator.popView();
        console.log("quitBtnClicked : " + value);
    };
    
    this.popUpKeyboard = function() {
        huf.pal.regDlgSendCallback("sendBtnClicked",this.sendBtnClicked.bind(this));
        huf.pal.regDlgQuitCallback("quitBtnClicked",this.quitBtnClicked.bind(this));
        console.log("call popUpKeyboard : ");
        huf.pal.popUpKeyboard(L('Text'),L('Please enter your text'),"false","",L('Send'),L('Quit'));
    };
    
	this.keyboardBtnPressed = function(e)
	{
		$("mediaControl-keyboardBtn").style.opacity=0.5;
	}.bind(this)
	
	this.keyboarBtnReleased = function(e)
	{
		$("mediaControl-keyboardBtn").style.opacity=1;
		huf.navigator.pushView("KeyboardPage",KeyboardPageAssistant);
		this.popUpKeyboard();
	}.bind(this)
	
	Event.observe($("mediaControl-keyboardBtn"), viewUtil.clickEventName(), this.keyboardBtnPressed);
	Event.observe($("mediaControl-keyboardBtn"), viewUtil.clickUpEventName(), this.keyboarBtnReleased);
	this.trace("complete");
};

MediaControlAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */

	// check permission
	spark.globalUIObject.currentService.checkPermission();
};

MediaControlAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

MediaControlAssistant.prototype.cleanup = function(event) {
	Event.stopObserving($("mediaControl-backBtn"), viewUtil.clickEventName(), this.backBtnPressed);
	Event.stopObserving($("mediaControl-backBtn"), viewUtil.clickUpEventName(), this.backBtnReleased);
	
	Event.stopObserving($("anchorPlay"), viewUtil.clickEventName(),this.tabFunctions.tabBarClicked);
	Event.stopObserving($("anchorGes"), viewUtil.clickEventName(), this.tabFunctions.tabBarClicked);
	
	huf.gesture.stopObserving("gestureDiv", "gesturestart", this.gestureFunctions.gesturestartHandler);
	huf.gesture.stopObserving("gestureDiv", "gestureend", this.gestureFunctions.gestureendHandler);
	
	Event.stopObserving($("navLeftBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navRightBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navUpBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navDownBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navOKBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	
	Event.stopObserving($("navLeftBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navRightBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navUpBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navDownBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navOKBtn"), viewUtil.clickUpEventName(), this.navFunctions.navBtnClicked);
	
	Event.stopObserving($("navSubtitleBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navMenuBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navLanguageBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	
	Event.stopObserving($("navRedBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navGreenBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navBlueBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navYellowBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	
	Event.stopObserving($("navFanViewBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navPreBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navNextBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navRewindBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navForwardBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navPlayBtn"), viewUtil.clickEventName(), this.navFunctions.navBtnClicked);
	Event.stopObserving($("navTrayBtn"), viewUtil.clickEventName(), this.tabFunctions.tabBarClicked);
	
	Event.stopObserving($("trayBtn"), viewUtil.clickEventName(),this.tabFunctions.tabBarClicked);
	Event.stopObserving($("preBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("nextBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("volumeUpBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("volumeDownBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("playBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	
	Event.stopObserving($("rewindBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("forwardBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	Event.stopObserving($("muteBtn"), viewUtil.clickEventName(), this.mediaFunctions.mediaBtnClicked);
	
	this.unregTouchFunctions = viewUtil.unregTouchFunctions;
	this.unregTouchFunctions();
	
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
};
