﻿/*
 * @author bart_lee 2010 09 29
 */


viewUtil = {
	debugMode: false,
	trace: function(message){
		if (viewUtil.debugMode) {
			console.log("[viewUtil] " + message);
			$("debugDiv").innerHTML = "[viewUtil] " + message;
		}
	},
	traceAll: function(options){
		for (var property in options) {
			console.log("  - " + typeof(property) + " : " + property + " = " + options[property]);
		}
		
	},
	initFontSize: function(){
		var sizeFontBase = (huf.pal.getResolutionWidth() > huf.pal.getResolutionHeight()) ? huf.pal.getResolutionHeight() :  huf.pal.getResolutionWidth();
		$('document-body').style.fontSize = sizeFontBase/320*100+"%";
	},
	regTouchFunctions: function(){
		if (huf.pal.os == "webOS") {
			console.log("regTouchFunctions webOS");
			Event.observe($('gestureDiv'), 'mousedown', this.mousedownHandler);
			Event.observe($('gestureDiv'), 'mouseup', this.mouseupHandler);
			Event.observe($('gestureDiv'), 'mousemove', this.mousemoveHandler);
		}
		else {
			console.log("regTouchFunctions android");
			Event.observe($('gestureDiv'), 'touchstart', this.mousedownHandler);
			Event.observe($('gestureDiv'), 'touchend', this.mouseupHandler);
			Event.observe($('gestureDiv'), 'touchmove', this.mousemoveHandler);
		}
	},
	unregTouchFunctions: function(){
		if (huf.pal.os == "webOS") {
			Event.stopObserving($('gestureDiv'), 'mousedown', this.mousedownHandler);
			Event.stopObserving($('gestureDiv'), 'mouseup', this.mouseupHandler);
			Event.stopObserving($('gestureDiv'), 'mousemove', this.mousemoveHandler);
		}
		else {
			Event.stopObserving($('gestureDiv'), 'touchstart', this.mousedownHandler);
			Event.stopObserving($('gestureDiv'), 'touchend', this.mouseupHandler);
			Event.stopObserving($('gestureDiv'), 'touchmove', this.mousemoveHandler);
		}
	},
	preventDefault: function(e){
		if (huf.pal.os == "webOS") {
		}
		else {
			/*
			 * http://code.google.com/p/android/issues/detail?id=5491
			 */
			e.preventDefault();
		}
	},
	clickEventName: function(){
		if (huf.pal.os == "webOS") {
			return 'click';
		}
		else {
			return 'touchstart';
		}
	},
	clickDownEventName: function(){
		return 'touchstart';
	},
	clickUpEventName: function(){
		return 'touchend';
	},
	/*------------------------------------------------------------------
	 * change image src with js
	 * (need predefine rollover and rollout in html)
	 * because of scale issue, css can't handle it
	 ------------------------------------------------------------------*/
	rollOver: function(imageID){
		$(imageID).src = $(imageID).getAttribute('rollover');
	},
	rollOut: function(imageID){
		$(imageID).src = $(imageID).getAttribute('rollout');
	},
}