﻿function ScanningAssistant() {

}

var activate = false;
ScanningAssistant.prototype.setup = function(){
	console.log("ScanningAssistant.prototype.setup");
	//-----------------------------------------------------------------------------
	//---------------------init--debugMode--trace------------------------------
	//-----------------------------------------------------------------------------
	this.trace = viewUtil.trace;
	this.trace("init Scene");
	
	this.myServers = new Array(0);
	//-----------------------------------------------------------------------------
	//---------------------init auto discovery------------------------------
	//-----------------------------------------------------------------------------
	this.buttonFunctions = {
		retryDown: function(event){
			$(autoBtnDiv).style.opacity = "0.5";
		},
		
		retryUp: function(event){
			$(autoBtnDiv).style.opacity = "1";
			this.stopTimer();
			this.scanningAnimation.stopAnimation();
			huf.navigator.popView();
			huf.navigator.pushView("Scanning",ScanningAssistant);
		}
	}
	
	Event.observe($("autoBtnDiv"), "touchstart", this.buttonFunctions.retryDown.bindAsEventListener(this, 'autoImageDiv'));
	Event.observe($("autoBtnDiv"), "touchend", this.buttonFunctions.retryUp.bindAsEventListener(this, 'autoImageDiv'));
	
	//-----------------------------------------------------------------------------
	//-----------------------Scan Servers-----------------------------------------
	//-----------------------------------------------------------------------------
	this.stopTimer = function(){
		if (this.discoveryTimer) {
			this.trace("----------stopTimer----------")
			window.clearTimeout(this.discoveryTimer);
		}
	}

	this.startTimer = function(){
		this.discoveryTimer = window.setTimeout(function(){
			//this.pushRetryPage();
			var tempData = [];
			this.refreshServers(tempData);
			this.setState("serverList");
		}.bind(this), 15000);
	}

	this.sysCallback_addDevice = function(obj){
		this.setState("serverList");
		this.stopTimer();
		var isDuplicated = false;
		for (var i = 0; i < this.myServers.length; ++i) 
		{
			if (obj.usn == this.myServers[i].usn) 
			{
				isDuplicated = true;
				break;
			}
		}
		if (!isDuplicated) {
			this.myServers.push(obj);
		}
		this.refreshServers(this.myServers);
	}.bind(this)
	
	this.sysCallback_removeDevice = function(obj){
		for (var i = 0; i < this.myServers.length; i++) {
			if (obj.usn == this.myServers[i].usn) {
				this.myServers.remove(i);
			}
		}
		this.trace("sysCallback_removeDevice");
	}.bind(this)
	
	this.sysCallback_getAppList = function(appServerIndex){
		try {
			console.log("[Remote] sysCallback_getAppList begin");
			var deviceObj = this.myServers[appServerIndex];
			spark.globalUIObject.currentDevice = deviceObj;
			spark.globalUIObject.currentService = deviceObj.serviceArray[0];

			spark.globalUIObject.currentService.start();
			spark.globalUIObject.currentService.startMediaShare();
			
			if (spark.globalUIObject.apiVersion==1.0) 
			{
				spark.globalUIObject.moduleArray = deviceObj.serviceArray[0].playerArray[0].moduleArray;
				
				// send start http command
				console.log("[Remote1.0] sysCallback_getAppList startServer");
				spark.globalUIObject.currentService.startServer();

				huf.navigator.pushView("ModuleSelection", ModuleSelectionAssistant);
			}
			console.log("sysCallback_getAppList end");
		}
		catch (error) {
			if (!spark.globalUIObject.currentDevice) {
				console.log("cannot connect to device");
			} else if (!spark.globalUIObject.currentService) {
				console.log("cannot connect to service");
			} else if (!spark.globalUIObject.moduleArray) {
				console.log("cannot connect to application");
			}
		}
	}.bind(this)
	
	this.setState = function(state){
		var slVisibility, scanVisibility, arVisibility;
		if (state == "scan") {
			scanVisibility = "visible";
			slVisibility = "hidden";
			arVisibility = "hidden";
			this.scanningAnimation.startAnimation();
		}
		else {
			scanVisibility = "hidden";
			slVisibility = "visible";
			arVisibility = "visible";
			this.scanningAnimation.stopAnimation();
		}
		$('serverListMid').style.visibility = slVisibility;
		$('scanMid').style.visibility = scanVisibility;
		$('autoBtnDiv').style.visibility = arVisibility;
	}
	
	this.pushRetryPage = function(){
		this.trace("----- pushRetryPage");
		huf.navigator.pushView("RetryPage",RetryPageAssistant);
	}
	this.startDeviceDiscovery = function(){
		this.trace("startDeviceDiscovery start");
		
		
	/*----------------------------------------------
	* unmark when testing UI
	-----------------------------------------------*/
//		var tempData = [{
//			name: "device1"
//		}, {
//			name: "device2"
//		}, {
//			name: "device3"
//		}, {
//			name: "device4"
//		}, {
//			name: "device5"
//		}, {
//			name: "device6"
//		}, {
//			name: "device7"
//		}, {
//			name: "device8"
//		}, {
//			name: "device9"
//		}, {
//			name: "device10"
//		}, ];
//		this.refreshServers(tempData);
//		this.setState("serverList");
		
		this.startTimer();
		this.unregServers();
		this.myServers = new Array(0);
		console.log("-----------------------------------------------------------------");
		console.log("--start---------------------------------------------------------------");
		console.log("-----------------------------------------------------------------");
		spark.deviceMgr.startDeviceDiscovery("RemoteControl", this.sysCallback_addDevice, this.sysCallback_removeDevice);
		console.log("-----------------------------------------------------------------");
		console.log("--end---------------------------------------------------------------");
		console.log("-----------------------------------------------------------------");
		this.trace("startDeviceDiscovery end");
	}
	
	this.stopDeviceDiscovery = function(){
		this.trace("stopDeviceDiscovery init");
		spark.deviceMgr.stopDeviceDiscovery();
		this.trace("stopDeviceDiscovery complete");
	}
	
	///----------------------------------------------------------------------------------------------------
	///-----------refreshServers--------------------------------------------------------------------------
	///----------------------------------------------------------------------------------------------------
	
	this.serverFunctions = {
		serverDown: function(event){
			var data = $A(arguments);
			data.shift();
			this.serverIndex = data[0];
			this.trace("serverDown serverIndex : " + this.serverIndex);
		},
		serverUp: function(event){
			var data = $A(arguments);
			data.shift();
			
			var newServerIndex = data[0];
			this.trace("serverUp newServerIndex : " + newServerIndex);
			this.trace("this.moveTop : " + this.moveTop);
			this.trace("this.downTop : " + this.downTop);
			if (this.serverIndex == newServerIndex && this.moveTop - this.downTop < 5 && this.moveTop - this.downTop > -5) 
			{
				$(this.myServers[newServerIndex].usn).style.opacity = "0.5";
				var uuidOffset = this.myServers[newServerIndex].usn.indexOf("::");
				if (uuidOffset < 0) 
				{
					uuidOffset = 42;  //uuid:bd40ebb8-3a1f-3607-e3fa-6d494973714a
				}
				
				var uuidPC = this.myServers[newServerIndex].usn.substring(5, uuidOffset);
				spark.globalUIObject.password = huf.preferencesManager.getTargetPreferencesString(uuidPC, "password", "");
				spark.deviceMgr.getApplicationList(newServerIndex, this.myServers[newServerIndex], this.sysCallback_getAppList);
			}
		}
	}
	
	this.regServers = function(){
		for (var i = 0; i < this.myServers.length; i++) {
			Event.observe($(this.myServers[i].usn), "touchstart", this.serverFunctions.serverDown.bindAsEventListener(this, i));
			Event.observe($(this.myServers[i].usn), "touchend", this.serverFunctions.serverUp.bindAsEventListener(this, i));
		}
	}
	this.unregServers = function(){
		for (var i = 0; i < this.myServers.length; i++) {
			Event.stopObserving($(this.myServers[i].usn), viewUtil.clickEventName(), this.serverFunctions.serverClicked);
		}
	}
	
	this.refreshServers = function(servers){
		/* clear device list */
		$('tableParent').innerHTML = '';
		
		/* setup */
		var totalHeight = $('tableParent').clientHeight;
		var cellHeight = totalHeight / 4;     // simply set the height of cell is 1/4 of table parent
		
		/* create device list and append it to parent div */
		this.tableBase = new Element('div', {id:'deviceListBase', cellspacing:'0', cellpadding:'0'});
		$('tableParent').appendChild(this.tableBase);
		$('deviceListBase').addClassName('DeviceListBase');
		
		/* create the cell of each device and add them to the device list */
		for (var i = 0; i < servers.length; i++) {
			// create cell
			var cell = new Element('div', {id:servers[i].usn + ""});
			cell.addClassName('DeviceListCell');
			$('deviceListBase').appendChild(cell);
			cell.style.height = cellHeight + "px";
			
			// create icon
			var cellIcon = new Element('div');
			cellIcon.addClassName('DeviceListCellIcon');
			cell.appendChild(cellIcon);
			
			// create text
			var cellText = new Element('div');
			cellText.addClassName('DeviceListCellText');
			cellText.innerHTML = servers[i].name;
			cell.appendChild(cellText);
		}
		
		/* set height of viewable height, it is related to the range for scrolling */
		this.tableHeight = cellHeight*(servers.length);
		if (this.tableHeight < totalHeight) {
			this.tableHeight = totalHeight;
		}
		/* register server */
		this.regServers();
	}
	
	//-----------------------------------------------------------------------------
	//---------------------complete----------------------------------------------
	//-----------------------------------------------------------------------------
	
	
	/* Scanning Animation */
	
	this.scanningAnimation = {
		setup: function()
		{
			/* public attribute, can be exposed as parameter if necessary */
			this.timerInterval = 0.5; // sec
			this.animationImage = $('scanImage');
			var nHeight = huf.pal.getResolutionHeight();
			var nWidth = huf.pal.getResolutionWidth();
			if ((nHeight >= 924 && nHeight <= 1124 && nWidth == 600) || (nHeight == 600 && nWidth >= 924 && nWidth <= 1124)) {
				if (nHeight > nWidth){
					nHeight = 1024;
				}
				else{
					nWidth = 1024;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1380 && nWidth == 800) || (nHeight == 800 && nWidth >= 1180 && nWidth <= 1380)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1280 && nWidth == 720) || (nHeight == 720 && nWidth >= 1180 && nWidth <= 1280)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			var strResolution = "";
			if (nHeight > nWidth)
			{
				strResolution = "" + nHeight + nWidth;
			}
			else 
			{
				strResolution = "" + nWidth + nHeight;
			}
			this.srcPathArray = [
							"../Resource/" + strResolution + "/images/launch/android01.png",
							"../Resource/" + strResolution + "/images/launch/android02.png",
							"../Resource/" + strResolution + "/images/launch/android03.png",
							"../Resource/" + strResolution + "/images/launch/android04.png"
			               ];
			this.animationFrame = 0;             
			this.animationImage.src = this.srcPathArray[this.animationFrame];
			
			/* private attribute */
			this._animationTimer = null;
		},
		
		executeAnimation: function(e)
		{
			if (this.animationFrame < this.srcPathArray.length - 1)
				this.animationFrame++;
			else
				this.animationFrame = 0;
			
			this.animationImage.src = this.srcPathArray[this.animationFrame];
		},
		
		startAnimation: function(e)
		{
			this._animationTimer = new PeriodicalExecuter(this.executeAnimation.bind(this), this.timerInterval); 
		},
		
		stopAnimation: function(e)
		{
			if (this._animationTimer)
				this._animationTimer.stop();
		}
	}
	
	this.scanningAnimation.setup();
	
	/*-----------------------------------------------
	 ------------------- scroll-------------------
	 -----------------------------------------------*/
	this.oriTop = 0;
	this.getRealPoint = function(e){
		if (e.pageX) {
			return {
				"x": e.pageX,
				"y": e.pageY
			}
		}
		else {
			return {
				"x": e.touches[0].pageX,
				"y": e.touches[0].pageY
			}
		}
	}
	this.mousedownHandler = function(e){
		viewUtil.preventDefault(e);
		var realPoint = this.getRealPoint(e);
		this.originalPoint = {
			x: realPoint.x,
			y: realPoint.y
		};
		this.downTop = 0;
		this.moveTop = 0;
		captured = true;
	}.bind(this)
	
	this.mousemoveHandler = function(e){
		if (captured) {
			var realPoint = this.getRealPoint(e);
			var diffPoint = {
				x: realPoint.x - this.originalPoint.x,
				y: realPoint.y - this.originalPoint.y
			};
			this.oriTop = this.oriTop + diffPoint.y;
			this.moveTop = this.oriTop;
			$('deviceListBase').style.top = this.oriTop + "px";
			this.originalPoint.x = realPoint.x;
			this.originalPoint.y = realPoint.y;
		}
	}.bind(this)
	
	this.mouseupHandler = function(e){
		if (this.oriTop + this.tableHeight < $('tableParent').clientHeight) {
			this.oriTop = -this.tableHeight + $('tableParent').clientHeight;
		}
		else {
			if (this.oriTop > 0) {
				this.oriTop = 0;
			}
		}
		$('deviceListBase').style.top = this.oriTop + "px";
		captured = false;
	}.bind(this)
	
	Event.observe($('tableParent'), 'touchstart', this.mousedownHandler);
	Event.observe($('tableParent'), 'touchmove', this.mousemoveHandler);
	Event.observe($('tableParent'), 'touchend', this.mouseupHandler);
	
	//-------------------------------------------------------------------------------------------
	//-------- refreshScroll --------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	
	this.refreshScroll = function(e){
		if ($('deviceListBase')){
			$('deviceListBase').style.top = "0px";
			this.oriTop = 0;
		}
	}
	
	//-------------------------------------------------------------------------------------------
	//-------- WebSite --------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------	
	
	this.websiteBtnClicked = function(e){
		// link to webiside, define in html
		huf.pal.browseURL("http://www.cyberlink.com");
	}.bind(this)
	
	Event.observe($("scanning-webSiteText"), viewUtil.clickEventName(), this.websiteBtnClicked);
	
	this.trace("complete Scene");
};

ScanningAssistant.prototype.activate = function(event) {
	if (activate == true) 
		return;
	activate = true;
	console.log("ScanningAssistant.prototype.activate");
	//-----------------------------------------------------------------------------
	//-----------------------discovery servers-----------------------------------------
	//-----------------------------------------------------------------------------
	
	if (null != spark.globalUIObject.currentService)
	{
		spark.globalUIObject.currentService.disconnect();
	}
	this.setState("scan");
	spark.globalUIObject.currentDevice = null;
	spark.globalUIObject.currentService = null;
	spark.globalUIObject.moduleArray = null;
	window.setTimeout(function(){
		this.startDeviceDiscovery();
		this.refreshScroll();
	}.bind(this), 0);

};

ScanningAssistant.prototype.deactivate = function(event) {
	console.log("ScanningAssistant.prototype.deactivate");
	activate = false;
	this.stopDeviceDiscovery();
};

ScanningAssistant.prototype.cleanup = function(event) {
	
	if (null != spark.globalUIObject.currentService)
	{
		spark.globalUIObject.currentService.disconnect();
	}
	console.log("ScanningAssistant.prototype.cleanup");
	Event.observe($("scanning-webSiteText"), viewUtil.clickEventName(), this.websiteBtnClicked);
	this.unregServers();
	
};
