﻿/**
 * @author wisley_huang
 */

spark = {};

spark.globalUIObject = {};

// spark.deviceMgr
spark.deviceMgr =
{
	//////////////////////
	// ## Properties ## //
	//////////////////////
	
	// device raw Array,
	deviceRawArray : [],
	
	// deviceObj Array
	deviceArray : [],

	
	//////////////////////
	// ## Interfaces ## //
	//////////////////////
	
	// startDeviceDiscovery
	startDeviceDiscovery : function(strSpecifiedService, syscbAddDev, syscbRemoveDev)
	{
		console.log("[startDeviceDiscovery] startDeviceDiscovery begin");
		///Bug fix for PRT111503-0008
		spark.deviceMgr.deviceRawArray=[];
		spark.deviceMgr.deviceArray=[];

		// 0) Notification wifi status 
		huf.pal.queryWifiStatus("È necessario connettere questo disposntivo a una rete Wi-Fi per iniziare.");
		
	    // 1) Keep callback setting from UI
		spark.deviceMgr._syscbAddDev 		= syscbAddDev; 
		spark.deviceMgr._syscbRemoveDev 	= syscbRemoveDev;
		
		// 2) Keep specified Services that UI is interested in (ex : "RemoteControl")
		spark.deviceMgr._strSpecifiedService = strSpecifiedService;
	
		// 3) Add Device callback from HUF
		function _hufcbAddDev(device)
		{
			var urn = "urn:schemas-cyberlink-com:service:" + spark.deviceMgr._strSpecifiedService + ":1";
			console.log("spark.deviceMgr._hufcbAddDev() usn = " + device.usn + ", urn = " + urn);
			if (device.usn.search(urn) == -1) {
				console.log("spark.deviceMgr._hufcbAddDev() Filter out");
				return;
			}
			
			spark.deviceMgr.deviceRawArray.push(device);
			
			var length = spark.deviceMgr.deviceRawArray.length;
			if (length > 1)
			{
				// Keep device raw Array
				for (var i = 0; i < length-1; i++)
				{
					if (spark.deviceMgr.deviceRawArray[i].usn == device.usn)
					{
						// pop the duplicated one
						spark.deviceMgr.deviceRawArray.pop();
						
						// always update the location
						for (var j = 0; j < spark.deviceMgr.deviceArray.length; j++)
						{
							if (spark.deviceMgr.deviceArray[j].usn == device.usn)
							{
								spark.deviceMgr.deviceArray[j].location = device.location;
								break;
							}
						}
						console.log("spark.deviceMgr._hufcbAddDev() Already exist");
						return;
					}
				}
			}
			
			// Generate Device
			var device = device;
			device.strSpecifiedService = spark.deviceMgr._strSpecifiedService;
			new spark.Class.genDevice(device);	
		};
		
		// 4) Remove Device callback from HUF
		function _hufcbRemoveDev(device)
		{
			console.log("spark.deviceMgr._hufcbRemoveDev()");
			new spark.Class.removeDevice(device);
		};
		
		// 5) Set callback to HUF
		if (huf.pal.UPnPDiscovery)
			huf.pal.UPnPDiscovery.setCallback(_hufcbAddDev, _hufcbRemoveDev)
		
		// 6) Start UPnP Discovery
		if (huf.pal.UPnPDiscovery)
			huf.pal.UPnPDiscovery.startUPnPDiscovery(3, "urn:schemas-cyberlink-com:service:"+spark.deviceMgr._strSpecifiedService+":1");
/*
		// Testing : Virtual Server for RemoteControl
		var vObj =
		{
			 "cache-control":"max-age=180",
			 "host":"239.255.255.250:1900",
			 "location":"http://174.129.78.141/vServer/",
			 "nt":"upnp:rootdevice",
			 "nts":"ssdp:alive",
			 "server":"LINUX/2.4 UPnP/1.0 BRCM400/1.0",
			 "usn":"uuid:0018-f8d7-fe4c00009adc::urn:schemas-cyberlink-com:service:RemoteControl:1"
		};	
		_hufcbAddDev(vObj);
	
	
		// Testing : Virtual Server for MediaSyncGo
		var vObj =
		{
			 "cache-control":"max-age=180",
			 "host":"239.255.255.250:1900",
			 "location":"http://174.129.78.141/vServer/",
			 "nt":"upnp:rootdevice",
			 "nts":"ssdp:alive",
			 "server":"LINUX/2.4 UPnP/1.0 BRCM400/1.0",
			 "usn":"uuid:0018-f8d7-fe4c00009adc::upnp:rootdevice"
		};	
		_hufcbAddDev(vObj);
*/	
	},
	
	// stopDeviceDiscovery
	stopDeviceDiscovery : function()
	{
		if (huf.pal.UPnPDiscovery)
			spark.deviceMgr.deviceRawArray=[];
			spark.deviceMgr.deviceArray=[];
			huf.pal.UPnPDiscovery.stopUPnPDiscovery();
	},
	
	// getDeviceArray
	getDeviceArray : function()
	{
		return spark.deviceMgr.deviceArray;
	},
	
	// getApplicationList
	getApplicationList : function(serverIndex, oDevice, syscbGetAppList)
	{
		// 1) Keep application list callback
		spark.deviceMgr._syscbGetAppList = syscbGetAppList;
		
		// 2) Get application device
		var appDevice = spark.deviceMgr.deviceArray[serverIndex];
		var controlURL = appDevice.deviceInfo.controlURL;
		
		var bRemote20 = (controlURL.toLowerCase().indexOf("agent") != -1);
		console.log("[getApplicationList] bRemote20" + bRemote20);
		if (bRemote20 == true) 
		{
			spark.globalUIObject.apiVersion = 2.0;
			spark.Class._genObjectsV2(appDevice, serverIndex, oDevice);
		}
		else
		{
			spark.globalUIObject.apiVersion = 1.0;
			spark.Class._genObjects(appDevice, serverIndex, oDevice);
		};
	}
};
// End spark.deviceMgr

// spark.html5
spark.html5 = 
{
	_testHTML5 : function()
	{
		if (typeof(localStorage) == "undefined")
		{
			alert("Your browser does not support HTML5 localStorage. Try upgrading.");
		}
		else
		{
			try
			{
				var myobj = "[{'name':'Wisley', 'sex':'male'},  {'name':'Kate', 'sex':'female'}]";
				//var myobj = [{'name':'Wisley', 'sex':'male'},  {'name':'Kate', 'sex':'female'}];
				//var myobj = ['Wisley', 'male', 'Kate', 'female'];
				//localStorage.setItem("name", "Hello World!"); //saves to the database, ��key��, ��value��
				//localStorage.setItem("list", myobj.join(";")); //saves to the database, ��key��, ��value��
				//console.log("list = " + myobj.join("#"));
				//localStorage.setItem("list", myobj.join("#")); //saves to the database, ��key��, ��value��
				console.log("list3 = " + myobj);
				localStorage.setItem("list3", myobj); //saves to the database, ��key��, ��value��	
			}
			catch (e)
			{
				if (e == QUOTA_EXCEEDED_ERR)
				{
					alert("Quota exceeded!"); //data wasn��t successfully saved due to quota exceed so throw an error
				}
			}
		}
		
//		this.myvalue = localStorage.getItem("me");
//		this.myvalue = this.myvalue.split("#");
//		this.arrarsize = this.myvalue.length;
//		this.name = this.myvalue[0];
//		this.att = this.myvalue[1];
//		$('status-report').insert("<BR>");
// 		$('status-report').insert(this.name);
		
		//document.write(localStorage.getItem("name")); //Hello World!
		//localStorage.removeItem("name"); //deletes the matching item from the database
	}
};
// End of spark.html5


// spark.Class (pseudo-Class)
spark.Class = 
{
	// device pseudo-Class
	device : function(nameDevice, usnDevice, iconUrl, deviceInfo, locationIP)
	{
		this.serviceArray = [];
		this.usn = usnDevice;
		this.name = nameDevice;
		this.iconUrl = iconUrl;
		this.deviceInfo = deviceInfo;
		this.locationIP = locationIP;
		
		console.log("spark.Class.device() name = " + this.name);
		console.log("spark.Class.device() usn = " + this.usn);
		console.log("spark.Class.device() iconUrl = " + this.iconUrl);
		console.log("spark.Class.device() deviceInfo = " + this.deviceInfo);
		console.log("spark.Class.device() locationIP = " + this.locationIP);
	},
	
	// service RemoteControl pseudo-Class
	serviceRemoteControl : function(nameService, urlControl)
	{
		this.playerArray = [];
		this.name = nameService;
		this.syscbResponse = null;
		this.playerIndex = 0;
		this.moduleIndex = 0;
		this.udpIP = null;
		this.udpPort = null;
		this.urlControl = urlControl;	
	},
	
	// service MediaSyncGo pseudo-Class
	serviceMediaSyncGo : function(nameService, urlCDS, urlTranscode, usnDevice)
	{
		console.log("spark.Class.serviceMediaSyncGo() nameService = " + nameService);
		console.log("spark.Class.serviceMediaSyncGo() urlCDS = " + urlCDS);
		console.log("spark.Class.serviceMediaSyncGo() urlTranscode = " + urlTranscode);
		console.log("spark.Class.serviceMediaSyncGo() udn = " + usnDevice);

		this.name = nameService;
		this.urlCDS = urlCDS;
		this.urlTranscode = urlTranscode;
		this.usnDevice = usnDevice;

		this.syscbResponse = null;
	},	
	
	// player pseudo-Class
	player : function(namePlayer)
	{
		this.name = namePlayer;
		this.moduleArray = [];
		this.bIsLowEndApplication=false;
	},

// ============= Remote 2.0 Start =============

	// Get by querying get_app_list
	playerV2 : function(appID, appName, appVersion, appVersionType)
	{
		this.appID = appID;
		this.name = appName;
		this.version = appVersion;
		this.app_version_type = appVersionType;
		this.supportSurvicesArray = [];
		this.bLowEndApp = false;
	},
	
	controlInfo : function(udpToken, udpPort)
	{
		this.udp_token = udpToken;
		this.udp_port = udpPort;
		this.supportFeature = [];
	},

// ============= Remote 2.0 End =============

	// folder pseudo-Class
	folder : function()
	{
		this.id = "";
		this.name = "";
		this.amountVideo = 0;
	},
	
	// video pseudo-Class
	video : function()
	{
		this.ticket = "";
		this.id = "";
		this.urlThumbnail = "";
 		this.filepathThumbnail = "";
 		this.urlVideo = "";
 		this.filepathVideo = "";
 		this.title = "";
 		this.sizeTotal = "";
 		this.sizeDownloaded = "";
 		this.duration = "";
		this.status = "";
	},
	
	browseResult : function()
	{
		this.ticket = "";
		this.videoArray = [];
	},
	
	// generate deviceObj / Array
	genDevice : function(device)
	{
		console.log("spark.Class.genDevice()");
	
		var device = device;
		
		console.log("spark.Class.genDevice() Ajax.Request = " + device.location);
		
		// Get device root description
		new Ajax.Request
		(
			device.location,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("spark.Class.genDevice() onSuccess responseText = " + response.responseText);
					_startGen(device, response.responseXML);
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("spark.Class.genDevice() onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("spark.Class.genDevice() onException responseText = " + response.responseText);
				}.bind(this)
			}
		);					
		
		function _startGen(deviceInfo, xml)
		{
			console.log("spark.Class._startGen()");

			if (!(deviceInfo && xml)) return;
			
			var deviceInfo = deviceInfo;
			
			/// added by pochun to get location IP address
			var offset = deviceInfo.location.lastIndexOf(":");
			if (offset < 0) {
				offset = deviceInfo.location.length - 1;
			} 
			
			var locationIP = deviceInfo.location.substring(7, offset);
			console.log("spark.Class._startGen() locationIP = " + locationIP);
			
			var deviceName = xml.getElementsByTagName("friendlyName");
			if (deviceName)
			{
				deviceInfo.deviceName = deviceName[0].childNodes[0].nodeValue;
			}

			// Get icon url
			var iconElements = xml.getElementsByTagName("icon");
			if (iconElements) {
				var urlElements = iconElements[0].getElementsByTagName("url");
				if (urlElements) {
					deviceInfo.iconUrl = deviceInfo.location + urlElements[0].childNodes[0].nodeValue;
				}
			} else {
				console.log("spark.Class._startGen() Cannot find any icon tags");
			}
			
			/// BUG when there are multiple services provided by DH'S module
			/// We might not get proper service elements.
			/// Anson and Pochun
			var service = xml.getElementsByTagName("service");
			if (service)
			{
				
				switch (deviceInfo.strSpecifiedService)
				{
					case "RemoteControl":
					{
						console.log("spark.Class._startGen() RemoteControl");
						for (var i = 0; i < service.length; i++) {
							// Get serviceType
							var serviceName = service[i].getElementsByTagName("serviceType");
							if (serviceName) {
								deviceInfo.serviceName = serviceName[0].childNodes[0].nodeValue;
							}
							
							// Get interested services only
							var search = deviceInfo.serviceName.search(deviceInfo.strSpecifiedService);
							if (search == -1) {
								continue;
							}
							
							// Get controlURL
							var controlURL = service[i].getElementsByTagName("controlURL");
							if (controlURL) {
								
								deviceInfo.controlURL = controlURL[0].childNodes[0].nodeValue;
								
								if (deviceInfo.controlURL.indexOf("http://") < 0) {
									// Get control port
									var controlPort = service[i].getElementsByTagName("controlPort");
									if (controlPort) {
										deviceInfo.controlPort = controlPort[0].childNodes[0].nodeValue;
									}
									
									// Get control protocol
									var controlProtocol = service[i].getElementsByTagName("controlProtocol");
									if (controlProtocol) {
										deviceInfo.controlProtocol = controlProtocol[0].childNodes[0].nodeValue;
									}
									
									// Remote1.0 - deviceInfo.controlURL = RemoteControl
									// Remote2.0 - deviceInfo.controlURL = agent
									deviceInfo.controlURL = deviceInfo.controlProtocol + "://" + locationIP + ":" + deviceInfo.controlPort + deviceInfo.controlURL;
								}
								
								console.log("RemoteControl controlURL = " + deviceInfo.controlURL);
							}
							
							// generate Device objects
							var oDevice = new spark.Class.device(deviceInfo.deviceName, deviceInfo.usn, deviceInfo.iconUrl, deviceInfo, locationIP);
							
							// push oDevice to deviceArrary
							spark.deviceMgr.deviceArray.push(oDevice);
							
							// callback UI to add the device object
							spark.deviceMgr._syscbAddDev(oDevice).defer();
							
							// already found the interested service, so break the loop
							break;
						} 
					}
					break;
					
					case "Transcode":
					{
						for (var i = 0; i < service.length; i++) {
							// Get serviceType
							var serviceName = service[i].getElementsByTagName("serviceType");
							if (serviceName) {
								deviceInfo.serviceName = serviceName[0].childNodes[0].nodeValue;
							}
							
							var controlURL = service[i].getElementsByTagName("controlURL");
							console.log("controlURL = " + controlURL);
							
							var search = deviceInfo.serviceName.search("ContentDirectory");
							var tempRoot = deviceInfo.location;
							if (tempRoot.charAt(tempRoot.length - 1) == "/")
							{
								tempRoot = tempRoot.substring(0, tempRoot.length-1) 
							}		
						
							// Service : "ContentDirectory"
							if (search > 0) // found
							{
								deviceInfo.urlCDS = tempRoot + controlURL[0].childNodes[0].nodeValue;
								continue;
							}
							// Service : "Transcode"
							search = deviceInfo.serviceName.search("Transcode");
							if (search >0)
							{
								deviceInfo.urlTranscode = tempRoot + controlURL[0].childNodes[0].nodeValue;
								continue;
							}
							
							if (search == -1)
							{
								continue;
							}
					
							// already found the interested service, so break the loop
							break;
						} 
						
						// generate Device objects
						var oDevice = new spark.Class.device(deviceInfo.deviceName, deviceInfo.usn, deviceInfo.iconUrl);
						var oService = new spark.Class.serviceMediaSyncGo(deviceInfo.serviceName, deviceInfo.urlCDS, deviceInfo.urlTranscode, deviceInfo.usn);
						
						if (oDevice && oService) {
							// push oService into oDevice.serviceArray
							oDevice.serviceArray.push(oService);
							
							// push oDevice to deviceArrary
							spark.deviceMgr.deviceArray.push(oDevice);
							
							// callback UI to add the device object
							spark.deviceMgr._syscbAddDev(oDevice).defer();
						}
					}					
					break;
					
					default:
					break;	
				}
			}
		};	
	},
	
	_genObjects : function (appDevice, serverIndex, oDevice)
	{
		console.log("[Remote1.0] _genObjects begin");
		
		var deviceInfo = appDevice.deviceInfo;
		var locationIP = appDevice.locationIP;
		var serverIndex = serverIndex;
		var oDevice = oDevice;
			
		// JSON sample
		// var test = { "SupportedAPPList":[ { "APPType":"RemoteControl", "APPName":"PowerDVD", "APPID":"PowerDVDv11", "APPVer":"10.1234", "UID":"918819282", "ControlStatus":"Allowed", "ControlToken":"52627128", "UDP":"192.112.24.251:1688", "Capability": ["play", "stop", "pause"], "Modules":["Moive", "Video", "Music"] }, { "APPType":"MediaShare", "APPName":"PowerCinema", "APPID":"PowerCinemav8", "APPVer":"7.1234", "UID":"9188192233", "ControlStatus":"Denied", "ControlToken":"52627129", "UDP":"192.112.24.251:1688", "Capability": ["play", "stop", "pause"], "Modules":["Moive", "Video", "Music"] }, { "APPType":"MediaStreaming", "APPName":"PowerCinema2", "APPID":"PowerCinemav5", "APPVer":"7.1234", "UID":"9188192233", "ControlStatus":"Denied", "ControlToken":"52627121", "UDP":"192.112.24.251:1688", "Capability":["play", "stop", "pause"], "Modules":["Moive", "Video", "Music"] } ]};

		var url = deviceInfo.controlURL + "?query=GetApplication";
		console.log("spark.Class._genObjects() Ajax.Request = " + url);
				
		// Get player
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("spark.Class._genObjects() responseText = " + response.responseText);
					console.log("spark.Class._genObjects() status = " + response.status);

					console.log("spark.Class._genObjects() Parsing JSON : IN");
							
					// get JSON response
					try {
						var obj = response.responseText.evalJSON(true);
					} catch(e) {
						console.log("spark.Class._genObjects() Parsing JSON : Exception");
					}

					console.log("spark.Class._genObjects() Parsing JSON : OUT");

					console.log("spark.Class._genObjects() obj = " + obj);
							
					// generate Service objects
					var oService = new spark.Class.serviceRemoteControl(deviceInfo.serviceName, deviceInfo.controlURL);
							
					// generate Player objects (if exist)
					if (obj && obj.SupportedAPPList) 
					{
						console.log("spark.Class._genObjects() SupportedAPPList = " + obj.SupportedAPPList.length);

						for (var i = 0; i < obj.SupportedAPPList.length; i++)
						{
							oService.parseIPandPort(obj.SupportedAPPList[i].UDP, locationIP);
										
							var oPlayer = new spark.Class.player(obj.SupportedAPPList[i].APPID);
										
							// Keep player modules in property by array
							if (oPlayer && obj.SupportedAPPList[i].Modules) 
							{
								for (var j = 0; j < obj.SupportedAPPList[i].Modules.length; j++) 
								{
									oPlayer.moduleArray.push(obj.SupportedAPPList[i].Modules[j]);
								}
							}
							
							// check the version of PowerDVD
							if (1 == spark.globalUIObject.freeVersion)
							{
								oPlayer.bIsLowEndApplication = true;
								var nFeatureNum = 0;
								if (undefined != obj.SupportedAPPList[i].SupportedFeatures)
								{
									nFeatureNum = obj.SupportedAPPList[i].SupportedFeatures.length;
								}
								
								for (var j = 0; j < nFeatureNum; j++) 
								{
									if("RemoteControl" == obj.SupportedAPPList[i].SupportedFeatures[j])
									{
										oPlayer.bIsLowEndApplication = false;
									}
								}
							}
							
							if (true == oPlayer.bIsLowEndApplication)
							{
								huf.pal.popupAlert("PowerDVD Remote", "Questa applicazione è disponibile per la versione 12 Ultra/11 Ultra/11 Deluxe di PowerDVD.\r\nÈ necessario eseguire l\'aggiornamento di PowerDVD alla versione 12 Ultra o acquistare la versione corrispondente di PowerDVD Remote per la versione di PowerDVD posseduta.", "OK", "huf.navigator.refreshScanning");
								// change website to pay version of PowerDVD remote
								// huf.pal.browseURL("http://www.cyberlink.com");
								// huf.navigator.popViewsTo("Scanning");
								return;
							}
										
							// push oPlayer into oService.playerArray
							oService.playerArray.push(oPlayer);
						}
					} 
					else 
					{
						console.log("spark.Class._genObjects() Warning! No SupportedAPPList");
					}
					// push oService into oDevice.serviceArray
					oDevice.serviceArray.push(oService);
					
					// callback UI to get application list
					spark.deviceMgr._syscbGetAppList(serverIndex).defer();
					
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("spark.Class._genObjects() onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("spark.Class._genObjects() onException responseText = " + response.responseText);
				}.bind(this)
			}
		)
	},
	
	_genObjectsV2 : function (appDevice, serverIndex, oDevice)
	{
		console.log("[Remote2.0] Remote2.0 spark.Class._genObjectsV2()");
		
		var deviceInfo = appDevice.deviceInfo;
		var locationIP = appDevice.locationIP;
		var serverIndex = serverIndex;
		var oDevice = oDevice;
		
		console.log("[Remote2.0] spark.Class._genObjects() obj = name" + deviceInfo.serviceName + "controlURL" + deviceInfo.controlURL);
		
		// generate Service objects
		var oService = new spark.Class.serviceRemoteControl(deviceInfo.serviceName, deviceInfo.controlURL);
		
		// push oService into oDevice.serviceArray
		oDevice.serviceArray.push(oService);
		
		// callback UI to get application list
		// Call Scanning-assistant
		//spark.deviceMgr._syscbGetAppList(serverIndex).defer();
		spark.deviceMgr._syscbGetAppList(serverIndex);
		
		// JSON sample
/*		var test = { "SupportedAPPList":[ { 	"APPType":"RemoteControl", 
			    							   	"APPName":"PowerDVD", 
												"APPID":"PowerDVDv11", 
												"APPVer":"10.1234", 
												"ControlStatus":"Allowed", 
												"ControlToken":"52627128", 
												"UDP":"192.112.24.251:1688", 
												"Capability": ["play", "stop", "pause"], 
												"Modules":["Moive", "Video", "Music"] }*/ 

		/*var JSONExample = '[
							 {"app_id": "E236BEBA-0915-4484-971E-CAD2D2D19613",
							 "supported_services": ["RemoteControl", "WifiSync"], 
							  "app_version": "12.0", 
							  "app_name": "PowerDVD 12"}, 
							 {"app_id": "E236BEBA-0915-4484-971E-CAD2D2D19614",
							  "supported_services": ["MediaShare", "MediaStreaming"], 
							  "app_version": "1.0", 
							  "app_name": "PowerCinema"}
							]';
							*/

		// Http example
		// http://master:port/agent/get_app_list?apiver=2.0
		 
		var url = deviceInfo.controlURL + "get_app_list?apiver=2.0";
		console.log("[Remote2.0] Remote2.0 spark.Class._genObjects() Ajax.Request = " + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 get_app_list onSuccess responseText = " + response.responseText);
					_HandleGetAppListResponse(appDevice, serverIndex, oDevice, oService, response);
					
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 get_app_list onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 get_app_list onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
		
		function _HandleGetAppListResponse(appDevice, serverIndex, oDevice, oService, response)
		{
			console.log("[Remote2.0] Remote2.0 spark.Class.serviceRemoteControl _HandleGetAppListResponse");
			
			if (!response) return;
			
			var deviceInfo = appDevice.deviceInfo;
			var locationIP = appDevice.locationIP;
			var serverIndex = serverIndex;
			var oDevice = oDevice;
			
			// get JSON response
			try 
			{
				var obj = response.responseText.evalJSON(true); 
				console.log("[Remote2.0] _HandleGetAppListResponse OK");
			}
			catch(e) 
			{
				console.log("[Remote2.0] _HandleGetAppListResponse Parsing JSON : Exception");
			}

			
			if (!obj) return;
			
			for (var i = 0; i < obj.length; ++i)
			{
				var oPlayer = new spark.Class.playerV2(obj[i].app_id, obj[i].app_name, obj[i].app_version, obj[i].app_version_type);
				// Keep player support service
				if (oPlayer && obj[i].supported_services) 
				{
					var supportServiceNum = obj[i].supported_services.length;
					for (var j = 0; j < supportServiceNum; ++j)
					{
						// only keep RemoteControl & Media2PC
						var serviceName = obj[i].supported_services[j];
						if (serviceName == "RemoteControl" || serviceName == "Media2PC") 
						{
							oPlayer.supportSurvicesArray.push(obj[i].supported_services[j]);
						}
					}
					
					// check the version of PowerDVD
					if (1 == spark.globalUIObject.freeVersion)
					{
						oPlayer.bLowEndApp = true;
						
						for (var nCount = 0; nCount < supportServiceNum; ++nCount) 
						{
							if("RemoteControl" == obj[i].supported_services[nCount])
							{
								oPlayer.bLowEndApp = false;
							}
						}
					}
					
					if ((spark.globalUIObject.apiVersion == 1.0 && true == oPlayer.bLowEndApp) || 
					    (spark.globalUIObject.apiVersion == 2.0 && oService.isAcceptedVersion(oPlayer.app_version_type) == false))
					{
						huf.pal.popupAlert("PowerDVD Remote", "Questa applicazione è disponibile per la versione 12 Ultra/11 Ultra/11 Deluxe di PowerDVD.\r\nÈ necessario eseguire l\'aggiornamento di PowerDVD alla versione 12 Ultra o acquistare la versione corrispondente di PowerDVD Remote per la versione di PowerDVD posseduta.", "OK", "huf.navigator.refreshScanning");
						return;
					}
					
					// push oPlayer into oService.playerArray
					oService.playerArray.push(oPlayer);
				}
			}
			if (oService.playerArray[0])
			{
				spark.globalUIObject.supportServiceArray = oService.playerArray[0].supportSurvicesArray;
			}
			
			console.log("[Remote2.0] handle GetAppList OK");
			
			spark.globalUIObject.locationIP = appDevice.locationIP;
			
			spark.globalUIObject.nFailedCount = -1;
			
			// authentication
			oService.authentication();
		}
	},
	
	// remove deviceObj from Array
	removeDevice : function(device)
	{
		// Update deviceArray
		for (var i = 0; i < spark.deviceMgr.deviceArray.length; i++)
		{
			if (device.usn == spark.deviceMgr.deviceArray[i].usn)
			{
				// callback UI to remove the deviceObj
				spark.deviceMgr._syscbRemoveDev(spark.deviceMgr.deviceArray[i]).defer();
				
				// remove deviceObj from Array
				spark.deviceMgr.deviceArray.splice(i,1);

				// since we have found the deviceObj, break the loop
				break;
			}
		}		
	}
};
// End spark.Class (pseudo-Class)	


// spark.Class.serviceRemoteControl.prototype
spark.Class.serviceRemoteControl.prototype =
{
	setResponseCallback : function(syscbResponse){this.syscbResponse = syscbResponse;},
	getPlayerArray : function(){return playerArray;},
	getModuleArray : function(playerIndex){return playerArray[playerIndex].moduleArray;},
	getCurPlayerStatus : function(){return this._curCmd;},
	
	launch : function(playerIndex)
	{
		// Keep Player Index
		this.playerIndex = playerIndex;
		
		// Send http Request
		this.sendHttpCommand("Launch");
	},
	
	selectModule : function(moduleIndex)
	{
		// Keep Module Index
		this.moduleIndex = moduleIndex;
				
		// Send http Request
		if (spark.globalUIObject.apiVersion == 1.0) 
		{
			this.sendHttpCommand("SelectModule", this.playerArray[this.playerIndex].moduleArray[this.moduleIndex]);
		}
		else
		{
			this.sendHttpCommand("SelectModule", spark.globalUIObject.controlInfo.supportFeature[moduleIndex]);
		}
	},
	
	start		: function(){this.sendHttpCommand("StartApplication");},
	launchApp	: function(){this.sendHttpCommand("LaunchApp");},
	play 		: function(){this.sendHttpCommand("PlayPause");},
	stop		: function(){this.sendHttpCommand("Stop");},
	next 		: function(){this.sendHttpCommand("Next");},
	previous 	: function(){this.sendHttpCommand("Previous");},
	forward		: function(){this.sendHttpCommand("Fastward");},
	rewind 		: function(){this.sendHttpCommand("Backward");},
	subtitle 	: function(){this.sendHttpCommand("Subtitle");},
	volumeUp 	: function(){this.sendHttpCommand("VolumeUp");},
	volumeDown 	: function(){this.sendHttpCommand("VolumeDown");},
	mute 		: function(){this.sendHttpCommand("Mute");},
	language 	: function(){this.sendHttpCommand("Language");},
	menu 		: function(){this.sendHttpCommand("Menu");},
	enter 		: function(){this.sendHttpCommand("OK");},
	arrowUp 	: function(){this.sendHttpCommand("Up");},
	arrowDown 	: function(){this.sendHttpCommand("Down");},
	arrowLeft 	: function(){this.sendHttpCommand("Left");},
	arrowRight 	: function(){this.sendHttpCommand("Right");},
	rotateLeft	: function(){this.sendHttpCommand("RotateLeft");},
	rotateRight	: function(){this.sendHttpCommand("RotateRight");},
	zoomIn		: function(){this.sendHttpCommand("ZoomIn");},
	zoomOut		: function(){this.sendHttpCommand("ZoomOut");},
	yellow		: function(){this.sendHttpCommand("Yellow");},
	blue		: function(){this.sendHttpCommand("Blue");},
	red			: function(){this.sendHttpCommand("Red");},
	green		: function(){this.sendHttpCommand("Green");},
	fanview		: function(){this.sendHttpCommand("FanView");},
	checkPermission : function()
	{
		if (spark.globalUIObject.apiVersion == 1.0) 
			this.sendHttpCommand10("CheckPermission");
	},
	parseIPandPort : function(udpRoot, locationIP)
	{
		// Parse IP and Port
		var udpRoot = udpRoot;
		var locationIP = locationIP;
		
		var nStart = udpRoot.search("//");
		var temp = null;
		if (nStart != -1) {
			temp = udpRoot.substring(nStart + 2);
		}
		else
		{
			temp = udpRoot;
		}
		
		var n1 = temp.search(":");
//		var n2 = temp.search("/");
//		if (n2 != -1)
//		{
//			temp = temp.substr(0, n2);
//		}
		
		if (n1 == -1) // no port, set default port = 80
		{
			this.udpIP = locationIP;
			this.udpPort = temp;
		}
		else
		{
			this.udpIP = locationIP;
			this.udpPort = temp.substring(n1+1);
		}
		huf.pal.MouseEvent.setUDPIpPort(this.udpIP, this.udpPort);
	},
	
//------------------------ Remote2.0 ------------------------	
	
	QueryAPIVersion: function()
	{
		console.log("[Remote2.0] GetAPIVersion");
		spark.globalUIObject.apiVersion = 1.0;
        
        // Http request example : http://master:port/agent/api_supported?apiver=2.0 
		
		var url = this.urlControl.toString() + "api_supported?apiver=2.0";
        console.log("[Remote2.0] GetAPIVersion url" + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetAPIVersion= " + 2.0);
					spark.globalUIObject.apiVersion = 2.0;
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetAPIVersion onFailure");
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetAPIVersion onException");
				}.bind(this)
			}
		);
    },
	
	getFreePaidDeviceAppID : function()
	{
		if (spark.globalUIObject.deviceAppID)
			return spark.globalUIObject.deviceAppID;

		const DEVICE_APP_FREEID = "urn:uuid:8eb08d9e-c8a1-11e0-8577-e0cb4e9e02da"; 
		const DEVICE_APP_PAIDID = "urn:uuid:8f3219ae-c8a1-11e0-b1c3-e0cb4e9e02da";
		
		console.log("[Remote2.0] getFreePaidDeviceAppID spark.globalUIObject.freeVersion" + spark.globalUIObject.freeVersion);
		if (1 == spark.globalUIObject.freeVersion)
		{
			spark.globalUIObject.deviceAppID = 	DEVICE_APP_FREEID;
		}
		else
		{
			spark.globalUIObject.deviceAppID = 	DEVICE_APP_PAIDID;
		}

		return spark.globalUIObject.deviceAppID;
	},
	
	isAcceptedVersion : function(buildType)
	{
		console.log("[Remote2.0] isAcceptedVersion buildType" + buildType);
		function versionUnit(version, freeState, paidState)
		{
			this.versionType = version;
			this.free = freeState;
			this.paid = paidState;
		}
		
		var versionMap = new Array();
		versionMap.push(new versionUnit("ULTRA", "Accept", "Accept"));
		versionMap.push(new versionUnit("PRO", "Reject", "Accept"));
		versionMap.push(new versionUnit("STANDARD", "Reject", "Accept"));
		versionMap.push(new versionUnit("OEM", "Reject", "Reject"));
		versionMap.push(new versionUnit("OEM_STANDARD", "Reject", "Accept"));
		versionMap.push(new versionUnit("CORPORATE", "Reject", "Reject"));
		versionMap.push(new versionUnit("TRIAL", "Accept", "Accept"));
		versionMap.push(new versionUnit("EXPRESS", "Reject", "Accept"));
		versionMap.push(new versionUnit("Others", "Reject", "Accept")); // i = length-1
		
		var state = 0;
		for (var i =0; i<versionMap.length; ++i)
		{
			if (buildType == versionMap[i].versionType || i == (versionMap.length-1))
			{
				if (1 == spark.globalUIObject.freeVersion)
				{
				 	if (versionMap[i].free == "Accept")
						return true;
				}
				else
				{
					if (versionMap[i].paid == "Accept")
						return true;
				}
			}
		}
		return false;
	},
	
	authentication : function()
	{
		console.log("[Remote2.0] authentication");
		console.log("[Remote2.0] password"+ spark.globalUIObject.password);
		
		// Http request example : 
		// http://master:port/agent/authentication?apiver=2.0&pass=1234&uuid=urn:uuid:337c8aaa-9725-3ee9-811a-0b21215b8b83
		// &deviceappid=urn:uuid:237c8bbb-9725-3ee9-811a-0b21215b8b84 

		var deviceAppid = "";
		if (spark.globalUIObject.currentService.playerArray)
		{
			deviceAppid = this.getFreePaidDeviceAppID();
			
			console.log("[Remote2.0] authentication deviceAppid" + deviceAppid);
		}
		var url = this.urlControl.toString()
		+ "authentication?apiver=2.0&pass="+spark.globalUIObject.password
											+"&uuid="+ encodeURIComponent(huf.pal.getDeviceID())
											+"&deviceappid=" + encodeURIComponent(deviceAppid);

		console.log("[Remote2.0] authentication url" + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 authentication onSuccess responseText = " + response.responseText);
					this.connect();
				}.bind(this),
				
				onFailure: function(response)
				{
					_HandleAuthentication(response);
					console.log("[Remote2.0] Remote2.0 authentication onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					_HandleAuthentication(response);
					console.log("[Remote2.0] Remote2.0 authentication onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
		
		function _HandleAuthentication(response)
		{
			console.log("[Remote2.0] _HandleAuthentication response" + response.responseText + "status" + response.status);
			switch (response.status) 
			{
				case 401:
				{
					spark.globalUIObject.nFailedCount = spark.globalUIObject.nFailedCount + 1;
					console.log("[Remote2.0] _HandleAuthentication response 401 nFailedCount" + spark.globalUIObject.nFailedCount);
					spark.globalUIObject.bIsPasswordValid = false;
					if (3 == spark.globalUIObject.nFailedCount) // if we popup password page for 3 times, back to server list
					{
						spark.globalUIObject.nFailedCount = 0;
						huf.navigator.popViewsTo("Scanning");
					}
					else if (huf.navigator._stackView[huf.navigator._stackView.length - 1].view != "PasswordChange") // make sure the PasswordChange page is unique
					{
						//spark.globalUIObject.nFailedCount = spark.globalUIObject.nFailedCount + 1;
						huf.navigator.pushView("PasswordChange", PasswordChange);
					}
					
					if (3 != spark.globalUIObject.nFailedCount) {
						huf.navigator.updateView();
					}
						
					break;
				}
				case 200:
				{
					console.log("[Remote2.0] _HandleAuthentication response 200");
					spark.globalUIObject.nFailedCount = 0;
					if (spark.globalUIObject.bIsPasswordValid == false)
					{
						spark.globalUIObject.bIsPasswordValid = true;
					}
					break;
				}
			}
		}
	},

	// Query Token
	connect : function()
	{
		console.log("[Remote2.0] Remote2.0 Connect Begin");
		// Http request example : 
		// http://master:port/agent/connect?apiver=2.0&app=PowerDVD&service=WifiSync&
		//      service=RemoteControl&LOCATION=http://slave-ip:port/upnp/desc.xml&uuid=urn:uuid:337c8aaa-9725-3ee9-811a-0b21215b8b83&pass=1234
		//		&deviceappid=urn:uuid:237c8bbb-9725-3ee9-811a-0b21215b8b84 
		
		var localLocation = huf.pal.MediaShareKernel.getLocation();
		console.log("[Remote2.0] Remote2.0 Connect getLocation" + localLocation);
		var strService ="";
		var strAppID = "";
		if (spark.globalUIObject.currentService.playerArray)
		{
			var playerV2 = spark.globalUIObject.currentService.playerArray[0];
			for (var i = 0; i<playerV2.supportSurvicesArray.length; ++i)
			{
				strService += "&service=";
				strService += spark.globalUIObject.supportServiceArray[i];
			}
			strAppID = playerV2.appID;
			console.log("[Remote2.0] Connect strService " + strService);
			console.log("[Remote2.0] Connect strAppID" + strAppID);
		}
		
		var urlBase = "connect?" 
				+"uuid="      + encodeURIComponent(huf.pal.getDeviceID())
				+"&pass="     + spark.globalUIObject.password
				+"&apiver=2.0"
				+"&app="      + encodeURIComponent(strAppID)
				+"&location=" + encodeURIComponent(localLocation) 
							  + strService
				+"&deviceappid=" + encodeURIComponent(spark.globalUIObject.deviceAppID) 
				;
	
		var url = this.urlControl.toString() + urlBase;
		console.log("[Remote2.0] Remote2.0 Connect : " + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Connect onSuccess responseText = " + response.responseText);
					_HandleConnectResponse(response);
					
					console.log("[Remote2.0] token" + spark.globalUIObject.token);
					huf.pal.MediaShareKernel.setToken(spark.globalUIObject.token, this.urlControl.toString());
					
					this.launchApp();
					
					huf.pal.MediaShareKernel.setAPIVersion20(spark.globalUIObject.apiVersion==2.0);
					
					// Query Control Info
					this.GetControlInfo();
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Connect onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Connect onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
		
		function _HandleConnectResponse(response)
		{
			if (!response) return;
			
			// get JSON response
			try 
			{
				var obj = response.responseText.evalJSON(true);
			}
			catch(e) 
			{
				console.log("[Remote2.0] Remote2.0 spark.Class.serviceRemoteControl _HandleConnectRespons Parsing JSON : Exception");
			}
			
			if (!obj) return;
			if (!obj.token) return;
			if (!obj.services) return;
			
			spark.globalUIObject.token = obj.token;
			console.log("[Remote2.0] Remote2.0 spark.Class.serviceRemoteControl _HandleConnectResponse token "+spark.globalUIObject.token);
			
			for (var i = 0; i < obj.services.length; ++i) 
			{
				var serviceID = obj.services[i].service_id;
				if (!serviceID) continue;
				if (serviceID.indexOf("RemoteControl") < 0) continue;
				
				var relativePath = obj.services[i].relative_path;
				if (!relativePath) continue;
				
				spark.globalUIObject.serviceRativePath = relativePath;
				
				console.log("[Remote2.0] Remote2.0 serviceRativePath: " + spark.globalUIObject.serviceRativePath);
			}
		}
	},
	
	disconnect : function()
	{
		console.log("[Remote2.0] Remote2.0 Disconnect");
		
		// Http request example :
		// http://master:port/agent/disconnect?apiver=2.0&token=abcdefghijklmnop
		
		if (!spark.globalUIObject.token) return;
		
		var url = this.urlControl.toString() + "disconnect?apiver=2.0&token=" + encodeURIComponent(spark.globalUIObject.token);
		
		console.log("[Remote2.0] Remote2.0 Disconnect url" + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 disconnect onSuccess responseText = " + response.responseText);
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 disconnect onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 disconnect onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
	},
	
	GetControlInfo : function()
	{
		console.log("[Remote2.0] Remote2.0 GetControlInfo");
		
		if (!spark.globalUIObject.token) return;
		if (!spark.globalUIObject.serviceRativePath) return;
		
		// Http request example :
		// http://master:port/agent/remotecontrol/get_control_info?apiver=2.0&token=abcdefghijklmnop
		
		var url = this.urlControl.toString() + spark.globalUIObject.serviceRativePath + "/get_control_info?apiver=2.0&token="
		+ encodeURIComponent(spark.globalUIObject.token);

		console.log("[Remote2.0] Remote2.0 GetControlInfo url" + url);
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetControlInfo onSuccess responseText = " + response.responseText);
					_HandleGetControlInfoResponse(response);
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetControlInfo onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 GetControlInfo onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
		
		//var testSample = '{"udp_token": 0, "supported_feature": ["Movie", "Device", "Video", "Music", "Photo"], "udp_port": 61000}';
			
		function _HandleGetControlInfoResponse(response)
		{
			if (!response) return;
			
			// get JSON response
			try 
			{
				var obj = response.responseText.evalJSON(true);
				console.log("[Remote2.0] Remote2.0 GetControlInfo finish parsing JSON");
			}
			catch(e) 
			{
				console.log("[Remote2.0] Remote2.0 GetControlInfo Parsing JSON : Exception");
			}

			if (!obj.udp_port) return;
			if (!obj.supported_features) return;
			
			console.log("[Remote2.0] Remote2.0 GetControlInfo parsing JSON result OK");
			
			spark.globalUIObject.currentService.parseIPandPort(":"+obj.udp_port, spark.globalUIObject.locationIP);
			var info = new spark.Class.controlInfo(obj.udp_token, obj.udp_port);

			for (var i = 0; i < obj.supported_features.length; ++i)
			{
				info.supportFeature.push(obj.supported_features[i]);
			}
			spark.globalUIObject.controlInfo = info;

			huf.navigator.pushView("ModuleSelection", ModuleSelectionAssistant);
		}
	},
	
	sendKeyboardText : function(Text)
	{
		console.log("[Remote2.0] Remote2.0 sendKeyboardText " + Text);
		
		if (!spark.globalUIObject.token) return;
		if (!spark.globalUIObject.serviceRativePath) return;
		
		// Http request example :
		// http://master:port/agent/remotecontrol/put_text_input?apiver=2.0&token=abcdefghijklmnop
		
		var url = this.urlControl.toString() + spark.globalUIObject.serviceRativePath + "/put_text_input?apiver=2.0&token="
		+ encodeURIComponent(spark.globalUIObject.token);

		console.log("[Remote2.0] Remote2.0 put_text_input url" + url);
		var JSONText = new String();
		var tempText = JSONText.concat("{\"action\":\"normal\",\"text\":", "\"", Text.toString(),"\"", "}");
		
		console.log("[Remote2.0] Remote2.0 sendKeyboardText " + tempText);
		unicodeText = encodeURI(tempText.toString);
		new Ajax.Request
		(
			url,
			{
				contentType:'application/json',
				method : "post",
				postBody:tempText,

				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 put_text_input onSuccess responseText = " + response.responseText);
					_HandleGetControlInfoResponse(response);
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 put_text_input onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 put_text_input onException responseText = " + response.responseText);
				}.bind(this)
			}
		);		
	},
//------------------------ Remote2.0 End------------------------

	sendHttpCommand : function(cmd, param)
	{
		if (spark.globalUIObject.apiVersion == 1.0) 
		{
			return this.sendHttpCommand10(cmd, param);
		}
		else
		{
			return this.sendHttpCommand20(cmd, param);
		}
	},
	
	sendHttpCommand10 : function(cmd, param)
	{
		console.log("[Remote1.0] sendHttpCommand");
		
		// validate check
		if (this.playerArray[this.playerIndex] == null || this.playerArray[this.playerIndex] == "undefined") {return;}
		
		// keep command
		this.curCmd = cmd;
		this.param = param;
		
		// send http request with assigned player and command
		// example : http://ip:port/RemoteControl/?cmd=VolumeUp&Target=PowerDVD
		
		// http encoding, "{" and "}" are illegal symbol, need to be encoded.
		var target = encodeURI(this.playerArray[this.playerIndex].name);
		var url = this.urlControl.toString() + "?cmd=" + this.curCmd + "&Target=" + target;
		if (this.param) {
			url += "&Tab=" + this.param;
		}
		
		url += "&FreeVersion=" + spark.globalUIObject.freeVersion;
		if (spark.globalUIObject.password) {
			url += "&passKey=" + spark.globalUIObject.password;
		}
		
		console.log("sendHttpCommand : " + url);
		huf.pal.httpCommand(url, this.handleHttpResponse);
	},
	
	sendHttpCommand20 : function(cmd, param)
	{
		console.log("[Remote2.0] sendHttpCommand");
		
		// validate check
		if (this.playerArray[this.playerIndex] == null || this.playerArray[this.playerIndex] == "undefined") {return;}
		
		function commandUnit(api, command, name, action)
		{
			this.api = api;
			this.command = command;
			this.name = name;
			this.action = action;
		}
		
		var commandMap = new Array();
		commandMap.push(new commandUnit("send_nav_cmd", "Up", 		"Arrow", "Up"));
		commandMap.push(new commandUnit("send_nav_cmd", "Down",		"Arrow", "Down"));
		commandMap.push(new commandUnit("send_nav_cmd", "Left",		"Arrow", "Left"));
		commandMap.push(new commandUnit("send_nav_cmd", "Right", 	"Arrow", "Right"));
		
		commandMap.push(new commandUnit("send_nav_cmd", "Subtitle", "SelectStream", "Subtitle"));
		commandMap.push(new commandUnit("send_nav_cmd", "Language",	"SelectStream", "Language"));
		commandMap.push(new commandUnit("send_nav_cmd", "Angle",	"SelectStream", "Angle"));
		
		commandMap.push(new commandUnit("send_nav_cmd", "Red",		"ColorKey", "Red"));
		commandMap.push(new commandUnit("send_nav_cmd", "Green",	"ColorKey", "Green"));
		commandMap.push(new commandUnit("send_nav_cmd", "Blue",		"ColorKey", "Blue"));
		commandMap.push(new commandUnit("send_nav_cmd", "Yellow",	"ColorKey", "Yellow"));
		
		commandMap.push(new commandUnit("send_nav_cmd", "Menu",		"Menu", ""));
		commandMap.push(new commandUnit("send_nav_cmd", "FanView",	"Chapter", ""));
		commandMap.push(new commandUnit("send_nav_cmd", "OK",		"Enter", ""));
		commandMap.push(new commandUnit("send_nav_cmd", "Return",	"Return", ""));
		
		commandMap.push(new commandUnit("send_mc_cmd",	"PlayPause","PlayPause", ""));
		commandMap.push(new commandUnit("send_mc_cmd",	"Stop",		"Stop", ""));
		commandMap.push(new commandUnit("send_mc_cmd",	"Previous",	"Previous", ""));
		commandMap.push(new commandUnit("send_mc_cmd",	"Next",		"Next", ""));
		commandMap.push(new commandUnit("send_mc_cmd",	"Fastward",	"FastForward", ""));
		commandMap.push(new commandUnit("send_mc_cmd",	"Backward",	"Backward", ""));
		
		commandMap.push(new commandUnit("send_dc_cmd",	"ZoomIn",	"Zoom", "In"));
		commandMap.push(new commandUnit("send_dc_cmd",	"ZoomOut",	"Zoom", "Out"));
		commandMap.push(new commandUnit("send_dc_cmd",	"RotateLeft", "Rotate", "Left"));
		commandMap.push(new commandUnit("send_dc_cmd",	"RotateRight","Rotate", "Right"));
		
		commandMap.push(new commandUnit("send_ac_cmd",	"VolumeUp",		"Volume", "Up"));
		commandMap.push(new commandUnit("send_ac_cmd",	"VolumeDown",	"Volume", "Down"));
		commandMap.push(new commandUnit("send_ac_cmd",	"Mute",			"Mute", ""));
		
		commandMap.push(new commandUnit("send_custom_cmd", "SelectModule",	"SelectMediaLib", ""));
		commandMap.push(new commandUnit("send_custom_cmd", "LaunchApp", 	"LaunchApp", "FullScreen"));
		
		for (var i =0; i<commandMap.length; ++i)
		{
			/*
			console.log("[Remote2.0] Remote2.0 sendHttpCommand api"+ commandMap[i].api);
			console.log("[Remote2.0] Remote2.0 sendHttpCommand command"+ commandMap[i].command);
			console.log("[Remote2.0] Remote2.0 sendHttpCommand name"+ commandMap[i].name);
			console.log("[Remote2.0] Remote2.0 sendHttpCommand action"+ commandMap[i].action);
			console.log("[Remote2.0] Remote2.0 sendHttpCommand input cmd"+ cmd);*/

			if (cmd == commandMap[i].command)
			{
				if ("SelectModule" == commandMap[i].command)
				{
					return this.sendCommand(commandMap[i].api, commandMap[i].name, param);
				}
				else
				{
					return this.sendCommand(commandMap[i].api, commandMap[i].name, commandMap[i].action);
				}	
			}
		}
	},
	
	sendCommand : function(api, name, action)
	{
		// http://master:port/agent/remotecontrol/send_nav_cmd?apiver=2.0&token=abcdef&name=[id]&action=[action]&param=[value 1]&param=[value 2]
		// [id]: the name of navigation command. 
		// [action]: optional. the action for this specified command. 
		// [value 1], [value 2]…,[value n]: optional. The additional parameters for this specified command.
		
		console.log("[Remote2.0] sendCommand");
		
		// validate check
		if (this.playerArray[this.playerIndex] == null || this.playerArray[this.playerIndex] == "undefined") {return;}
		
		var url = this.urlControl.toString() + spark.globalUIObject.serviceRativePath + "/"+api+
		"?apiver=2.0&token=" + encodeURIComponent(spark.globalUIObject.token) + "&name=" + name;
		if(action)
		{
			url += "&action=" +action;
		}
		
		console.log("[Remote2.0] Remote2.0 sendCommand : " + url);
		
		new Ajax.Request
		(
			url,
			{
				method : "get",
				onSuccess: function(response)
				{
					console.log("[Remote2.0] Remote2.0 sendCommand onSuccess responseText = " + response.responseText);
				}.bind(this),
				
				onFailure: function(response)
				{
					console.log("[Remote2.0] Remote2.0 sendCommand onFailure responseText = " + response.responseText);
				}.bind(this),
				
				onException: function(response)
				{
					console.log("[Remote2.0] Remote2.0 sendCommand onException responseText = " + response.responseText);
				}.bind(this)
			}
		);
	},
	
	handleHttpResponse : function(httpStatusCode)
	{
		if (spark.globalUIObject.apiVersion != 1.0)
			return;
			
		console.log("handleHttpResponse httpStatusCode - "+httpStatusCode);
		// handle the http status code 
		switch(httpStatusCode){
			case "401":
			{
				spark.globalUIObject.bIsPasswordValid = false;
				if (3 == spark.globalUIObject.nFailedCount) // if we popup password page for 3 times, back to server list
				{
					spark.globalUIObject.nFailedCount = 0;
					huf.navigator.popViewsTo("Scanning");
				}
				else if (huf.navigator._stackView[huf.navigator._stackView.length - 1].view != "PasswordChange") // make sure the PasswordChange page is unique
				{
					spark.globalUIObject.nFailedCount = spark.globalUIObject.nFailedCount + 1;
					huf.navigator.pushView("PasswordChange", PasswordChange);
				}
				
				return false;
			}
			case "200":
			{
				spark.globalUIObject.nFailedCount = 0;
				if (spark.globalUIObject.bIsPasswordValid == false)
				{
					spark.globalUIObject.currentService.start();
					// MediaShare already started, send start http command only.
					spark.globalUIObject.currentService.startServer();
					spark.globalUIObject.bIsPasswordValid = true;
				}
				return true;
			}
			default:
				return false;
		}
	},
	
	sendMouseEvent : function(dx, dy, dwFlags)
	{
		if (!huf.pal.MouseEvent)
			return;
			
		var IP = this.udpIP;
		var Port = this.udpPort;
		var tag = 19277;
		var length = 32;
		var token = 0;
		var type = huf.pal.MouseEvent.TYPE.INPUT_MOUSE;
		var dx = dx;
		var dy = dy;
		var mouse_data = 0;
		var dwFlags = dwFlags;
		var time = 0;
		var auth_id = 0;
		
		if(spark.globalUIObject.apiVersion == "2.0")
		{
			//if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEventV2(IP, Port, tag, length, token, type, dx, dy, mouse_data, dwFlags, time);
			}		
		}
		else
		{
			//if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEvent(IP, Port, type, auth_id, dx, dy, mouse_data, dwFlags, time);
			}
		}	
	},
	
	sendMouseWheelEvent : function(mouse_data)
	{
		if (!huf.pal.MouseEvent)
			return;
			
		var IP = this.udpIP;
		var Port = this.udpPort;
		var tag = 19277;
		var length = 32;
		var token = 0;
		var auth_id = 0;
		var Mouse_data = mouse_data;
		var time = 0;
		var type = huf.pal.MouseEvent.TYPE.INPUT_MOUSE;
		var dx = 0;
		var dy = 0;
		var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_WHEEL;
		
		if(spark.globalUIObject.apiVersion == "2.0")
		{
			//if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEventV2(IP, Port, tag, length, token, type, dx, dy, mouse_data, dwFlags, time);
			}		
		}
		else
		{
			//if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEvent(IP, Port, type, auth_id, dx, dy, mouse_data, dwFlags, time);
			}
		}		
	},
	
	sendLButtonDownEvent : function()
	{
		console.log("[PDVD Remote] sendLButtonDownEvent");
		var IP = this.udpIP;
		var Port = this.udpPort;
		var tag = 19277;
		var length = 32;
		var token = 0;
		var auth_id = 0;
		var Mouse_data = 0;
		var time = 0;
		var type = huf.pal.MouseEvent.TYPE.INPUT_MOUSE;
		var dx = 0;
		var dy = 0;
		var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_LEFTDOWN;;
		
		if(spark.globalUIObject.apiVersion == "2.0")
		{
			if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEventV2(IP, Port, tag, length, token, type, dx, dy, mouse_data, dwFlags, time);
			}		
		}
		else
		{
			if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEvent(IP, Port, type, auth_id, dx, dy, mouse_data, dwFlags, time);
			}
		}
	},
	sendLButtonUpEvent : function()
	{
		console.log("[PDVD Remote] sendLButtonUpEvent");
		var IP = this.udpIP;
		var Port = this.udpPort;
		var tag = 19277;
		var length = 32;
		var token = 0;
		var auth_id = 0;
		var Mouse_data = 0;
		var time = 0;
		var type = huf.pal.MouseEvent.TYPE.INPUT_MOUSE;
		var dx = 0;
		var dy = 0;
		var dwFlags = huf.pal.MouseEvent.DWFLAGS.MOUSEEVENTF_LEFTUP;;
		
		if(spark.globalUIObject.apiVersion == "2.0")
		{
			if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEventV2(IP, Port, tag, length, token, type, dx, dy, mouse_data, dwFlags, time);
			}		
		}
		else
		{
			if (huf.pal.MouseEvent)
			{
				// Marked for emulator
				huf.pal.MouseEvent.sendMouseEvent(IP, Port, type, auth_id, dx, dy, mouse_data, dwFlags, time);
			}
		}
	},
	
	startMediaShare : function()
	{
		console.log("[startMediaShare]");
		if (!huf.pal.MediaShareKernel.isStarted()){
			var uuid = huf.pal.getDeviceID();
			var strModelName = huf.pal.getDeviceModelName();
			huf.pal.MediaShareKernel.startService(uuid, strModelName);
			
			if (huf.pal.MediaShareKernel.isImageLibraryShared() == false)
				huf.pal.MediaShareKernel.shareImageLibrary(true);
	
			if (huf.pal.MediaShareKernel.isVideoLibraryShared() == false)
				huf.pal.MediaShareKernel.shareVideoLibrary(true);
		}
	},
	
	stopMediaShare : function()
	{
		console.log("[stopMediaShare]");
		if (huf.pal.MediaShareKernel.isStarted()){
			huf.pal.MediaShareKernel.stopService();
			
			if (huf.pal.MediaShareKernel.isImageLibraryShared() == true)
				huf.pal.MediaShareKernel.shareImageLibrary(false);
						
			if (huf.pal.MediaShareKernel.isVideoLibraryShared() == true)
				huf.pal.MediaShareKernel.shareVideoLibrary(false);
		}
	},
	
	// ==================== Remote 1.0 only ============================
	startServer	: function()
	{
		if (spark.globalUIObject.apiVersion != 1.0)
			return;
			
		this.sendMediaShareCommand("StartServer");
	},
	stopServer 	: function()
	{
		if (spark.globalUIObject.apiVersion != 1.0)
			return;
			
		this.sendMediaShareCommand("StopServer");
	},
	
	sendMediaShareCommand : function(cmd)
	{
		// send http request to start server for media share
		// example : http://ip:port/RemoteControl/?cmd=StartServer&LOCATION=location&USN=usn
		
		var localLocation = huf.pal.MediaShareKernel.getLocation();
		var localUsn = huf.pal.getDeviceID()+"::upnp:rootdevice";
		
		var url = this.urlControl.toString() + "?app=Media2PC" + "&cmd=" + cmd + "&LOCATION=" + localLocation + "&USN=" + localUsn;
		
		if (spark.globalUIObject.password) {
			url += "&passKey=" + spark.globalUIObject.password;
		}
		huf.pal.httpCommand(url, this.handleHttpResponse);
	}
	// =================================================================
};
// End spark.Class.serviceRemoteControl.prototype


// spark.Class.serviceMediaSyncGo.prototype
spark.Class.serviceMediaSyncGo.prototype =
{
	browse : function (option)
	{
		console.log("mediaSyncGo : start browsing");
		
		var option = option;
		
		console.log("this.urlCDS = " + this.urlCDS);
		
		option.browseRoot = this.urlCDS;
		
		if (spark.browseMgr.browse)
		{
			// return ticket of this browsing task
			return spark.browseMgr.browse(option);
		}
	},
	
	download : function (option)
	{
		console.log("mediaSyncGo : start downloading");
		spark.downloadMgr.download(option);
	},
	
	cancelDownload : function ()
	{
		console.log("mediaSyncGo : cancel downloading");
		spark.downloadMgr.cancelDownload();
	},
	
	getDownloadQuere : function()
	{
		console.log("mediaSyncGo : get download queue");
		return spark.downloadMgr.downloadQueue;
	},
	
	addObjectToDownloadQueue : function(video)
	{
		console.log("mediaSyncGo : add object to download queue");
		spark.downloadMgr.addObjectToDownloadQueue(video);
	},

	removeObjectFromDownloadQueue : function(video)
	{
		console.log("mediaSyncGo : remove object from download queue");
		spark.downloadMgr.removeObjectFromDownloadQueue(video);
	},
};
// End spark.Class.serviceMediaSyncGo.prototype

// spark.Class.video.prototype
spark.Class.video.prototype = 
{
	play : function() {}
};
// End spark.Class.video.prototype

// spark.browseMgr
spark.browseMgr =
{
	browse : function (option)
	{
		var option = option;
		console.log("sysSpark : start browse");
		
		// Set Callback
		spark.browseMgr._syscbBrowseSuccess = option.syscbBrowseSuccess;
		spark.browseMgr._syscbBrowseFailure = option.syscbBrowseFailure;
		
		// Callback UI with Ticket and cdsArray
		var browseTicket = _createID();
		var browseType = option.strBrowseType; // All_Video / Folder / One_Video
	
		var start = option.nStart;
		var range = option.nCount;
		//var cds = new CDSBrowser("http://174.129.78.141/vServer/?cmd=CDS", {onSuccess:onBrowseSuccess, onFailure:onBrowseFailure, ticket:browseTicket});
		var cds = new CDSBrowser(option.browseRoot, {onSuccess:onBrowseSuccess, onFailure:onBrowseFailure, ticket:browseTicket});

		var objectID = "0"; //0, 103, 116 are available
		var browseFlag = "BrowseDirectChildren"; // "BrowseDirectChildren", "BrowseMetadata"
		var filter = "*" // "*", "dc:title"
		var sortCriteria = ""; // ""	
		
		switch(browseType)
		{
			case "All_Video" :
			{
				objectID = "116";
				browseFlag = "BrowseDirectChildren";
			}
			break;
			
			case "Folders" :
			break;
			
			case "One_Folder" :
			break;
			
			case "One_Video":
			{
				objectID = option.objectID;
				browseFlag = "BrowseMetadata";
			}
			break;
			
			default : // return ticket with null
			return null;
		}
		
		// Start Browsing
		cds.browse(objectID, browseFlag, filter, start, range, sortCriteria);
		
		function _createID()
		{ 
	        // http://www.ietf.org/rfc/rfc4122.txt 
		    var s = []; 
		    var hexDigits = "0123456789ABCDEF"; 
		    for (var i = 0; i < 8; i++)
			{ 
		        s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1); 
		    } 
		    s[12] = "4";  // bits 12-15 of the time_hi_and_version field to 0010 
		    s[16] = hexDigits.substr((s[16] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01 
		 
		    var uuid = s.join(""); 
		    return uuid; 
		};
		
		function onBrowseSuccess(resultObj)
		{
			console.log("sysSpark : browse success");

			// Callback UI
			var resultObj = resultObj;
			var browseResult = new spark.Class.browseResult();
			browseResult.ticket = resultObj.memo.ticket;
			
			for (var i=0; i<resultObj.result.length; i++)
			{
				var oVideo = new spark.Class.video();
				oVideo.ticket = resultObj.memo.ticket;
				oVideo.id = resultObj.result[i].$attribute["id"];
				oVideo.title = resultObj.result[i]["dc:title"].$value;
				
				// Get resource according to the profile setting, here use the first resource as profile
				// If there is no resource matched, you should set oVideo.urlVideo = null,
				// which means need to be transcoded later if it's added in downloadQueue by users.
				oVideo.urlVideo = resultObj.result[i]["res"][0].$value;
				
				browseResult.videoArray.push(oVideo);
			}
			
			if (spark.browseMgr._syscbBrowseSuccess)
			{
				spark.browseMgr._syscbBrowseSuccess(browseResult);
			}
			
			console.log("sysSpark : browse done!");
			
			// Start to download thumbnails
			/*
			 * ??
			*/
		};
	
		function onBrowseFailure(resultObj)
		{
			// Callback UI the failure ticket
			var ticket = resultObj.memo.ticket;
			if (spark.browseMgr._syscbBrowseFailure)
			{
				spark.browseMgr._syscbBrowseFailure(ticket);
			}
		};
		
		return browseTicket;
	}
};
// End spark.browseMgr

// spark.downloadMgr
spark.downloadMgr =
{
	//////////////////////
	// ## Properties ## //
	//////////////////////
	
	// download queue
	downloadQueue : [],
	transcodeQueue : [],
	_curIndex : 0,
	_timer : null,
	
	//////////////////////
	// ## Interfaces ## //
	//////////////////////
	init : function()
	{
		// restore downloadQueue / transcodeQueue
		if (typeof(localStorage) == "undefined")
		{
			alert("Your browser does not support HTML5 localStorage. Try upgrading.");
		}
		else
		{
			this.myvalue = localStorage.getItem("list");
			this.myvalue = this.myvalue.split("#");
		}	
	},

	addObjectToDownloadQueue : function (video)
	{
		console.log("spark.downloadMgr.addObjectToDownloadQueue() " + video.id);
		spark.downloadMgr.downloadQueue.push(video);
	},
	
	removeObjectFromDownloadQueue : function (video)
	{
		var found = false;
		
		var video = video;
		for (var i = 0; i < spark.downloadMgr.downloadQueue.length; i++)
		{
			if (video.id == spark.downloadMgr.downloadQueue[i].id)
			{
				console.log("spark.downloadMgr.removeObjectFromDownloadQueue() " + video.id);
				spark.downloadMgr.downloadQueue.splice(i,1);
				found = true;
			}
		}
		
		if (!found) {
			console.log("spark.downloadMgr.removeObjectFromDownloadQueue() Warning! Not found: " + video.id);
		}
	},
	
	download : function (option)
	{
		var option = option;
		
		// 1) Set Callback
		spark.downloadMgr._syscbDownloadSuccess = option.syscbDownloadSuccess;
		spark.downloadMgr._syscbDownloadFailure = option.syscbDownloadFailure;
		
		// 2) Check if any video needs to be transcoded in downloadQueue
		for (var i=0; i<spark.downloadMgr.downloadQueue.length; i++)
		{
			// Need to be transcoded
			if (spark.downloadMgr.downloadQueue[i].urlVideo == "")
			{
				// Push to transcodeQueue
				spark.downloadMgr.downloadQueue[i].status = "transcoding";
				spark.downloadMgr.transcodeQueue.push(spark.downloadMgr.downloadQueue[i]);
				
				// Send transcoding request to server
				/*
				 * Todd
				 */
			}
		}
		
		// 3) download 
		_download();
		spark.downloadMgr._timer = new PeriodicalExecuter(_download, 5);
		
		function _download()
		{
			console.log("spark.downloadMgr._download()");
			
			spark.downloadMgr.dumpDownloadQueue();
			
			var downloadQueue = spark.downloadMgr.downloadQueue;
			
			if (spark.downloadMgr._curIndex >= downloadQueue.length) {
				spark.downloadMgr._curIndex = 0;
			}
			
			var index = spark.downloadMgr._curIndex;
			
			// Still transcoding...
			if (spark.downloadMgr.downloadQueue[index].urlVideo == "") {
				console.log("sysSpark : _download().Transcoding task");
				
				// query transcoding status
				/*
				 * Todd
		 		*/
				var bDone = false; //should be the result of above query
				// Transcode finished, so get urlVideo from CDS resource
				if (bDone) {
					var option = {};
					option.syscbBrowseSuccess = _onSuccess;
					option.syscbBrowseFailure = _onFailure;
					option.strBrowseType = "One_Video"; // All_Video / Folder / One_Video
					option.nStart = 0;
					option.nCount = 0;
					spark.browseMgr.browse(option);
					function _onSuccess(res){
					
					};
					
					function _onFailure(res){
					
					};
				}
				else // Still transcoding...
				{
				// do something
				}
			}
			else // Downloadable task
			{
				console.log("sysSpark : _download().Downloadable task");
				
				// If it is NOT downloading, trigger the event to download
				if (spark.downloadMgr.downloadQueue[index].status != "downloading") {
					// Start downloading
					spark.downloadMgr.downloadQueue[index].status = "downloading";
					
					var option = {};
					option.target = spark.downloadMgr.downloadQueue[index].urlVideo;
					option.targetDir = "/sdcard/";
					option.targetFilename = option.target.split("/").pop();
					option.subscribe = true;
					option.onSuccess = onDownlaodSuccess;
					option.onFailure = onDownloadFailure;
					
					huf.pal.DownloadManager.download(option);
				}
			}
			
			function onDownlaodSuccess(response){
				console.log("sysSpark : onDownlaodSuccess!");
				
				// change status to "downloading"
				spark.downloadMgr.downloadQueue[spark.downloadMgr._curIndex].status = "downloading";
				
				// callback to UI 		
				if (spark.downloadMgr._syscbDownloadSuccess) {
					spark.downloadMgr._syscbDownloadSuccess(response);
				}
				
				// download next video
				if (response.completed) {
					console.log("sysSpark : download Completed");
					spark.downloadMgr.downloadQueue[spark.downloadMgr._curIndex].status = "complete";
					var downloadQueue = spark.downloadMgr.downloadQueue;
					
					// remove downloaded from queue
					downloadQueue.shift();
						
					// still have downloadable/transcoding tasks
					if (downloadQueue.length > 0) {
						// do nothing
					}
					// no more downloadable task in queue, stop timer for downloading
					else {
						if (spark.downloadMgr._timer) {
							console.log("sysSpark : stop timer");
							spark.downloadMgr._timer.stop();
							spark.downloadMgr._timer = null;
						}
					}
				}
			};
			
			function onDownloadFailure(response){
				console.log("sysSpark : onDownloadFailure!");
				
				spark.downloadMgr.downloadQueue[spark.downloadMgr._curIndex].status = "failed";
				
				if (spark.downloadMgr._syscbDownloadFailure) {
					spark.downloadMgr._syscbDownloadFailure(response);
				}
				
				spark.downloadMgr._curIndex++;
			};
		};
	},
	
	cancelDownload : function()
	{
		console.log("sysSpark : cancelDownload!");
		
		// stop sysSark.downloadMgr
		if (spark.downloadMgr._timer) {
			console.log("sysSpark : stop timer");
			spark.downloadMgr._timer.stop();
			spark.downloadMgr._timer = null;
		}
		
		// stop downloading
		huf.pal.DownloadManager.cancelDownload();
	},
	
	dumpDownloadQueue : function() {
		var downloadQueue = spark.downloadMgr.downloadQueue;
		console.log("spark.downloadMgr.dumpDownloadQueue() Length = " + downloadQueue.length);
		for (var i = 0; i < downloadQueue.length; i++) {
			console.log("spark.downloadMgr.dumpDownloadQueue() " + i + ": " + downloadQueue[i].id + " " + downloadQueue[i].status);
		}
	},
};
// End spark.downloadMgr
