﻿/**
 * @author JERRY_TSENG
 * huf Android version.
 */

console.log("loading huf.js");

with (window) 
{	
	huf = {};
		
	// callback from Android native, should dispatch to right huf module
	{
		window.HUFPALNATIVECALLBACK = function(type)
		{
			args = $A(arguments);
			args.shift();
			//console.log("[HUFPALNATIVECALLBACK] type="+type);
			//console.log("Arguments:");
			//args.each(function(arg){console.log(arg);});
			//console.log("<END>");
			
			switch(type)
			{
				case "_onBack":
					huf.navigator.popView();
					if(huf.navigator._stackView.size()==0)
						huf.pal.popHostActivity();
					break;
				case "_onGesture":
					huf.gesture._onGesture(args);
					break;
				case "_onSSDPRspAdd":
					huf.pal.UPnPDiscovery._onSSDPRspAdd(args);
					break;
				case "_onSSDPRspRemove":
					huf.pal.UPnPDiscovery._onSSDPRspRemove(args);
					break;
				//case "_onServiceAdd":
				//	huf.pal.UPnPDiscovery._onServiceAdd(args);
				//	break;
				//case "_onServiceRemove":
				//	huf.pal.UPnPDiscovery._onServiceRemove(args);
				//	break;
			}
		}
	};
	
	// huf.pal methods and objects
	huf.pal = 
	{			
		os: "Android",
					
		getDeviceID: function()
		{
			var deviceID;
			if(window.HUFPALCORE)
				deviceID=window.HUFPALCORE.getDeviceID();
			
			console.log("[huf.pal.getDeviceID] deviceID="+deviceID);			
			return deviceID;
		},
		
		querySystemLanguage: function()
		{
			console.log("[huf.pal.querySystemLanguage]");
			if(window.HUFPALCORE){
				return window.HUFPALCORE.querySystemLanguage();
			}
		},
		
		queryWifiStatus: function(str)
		{
			console.log("[huf.pal.queryWifiStatus]");
			if(window.HUFPALCORE){
				return window.HUFPALCORE.queryWifiStatus(str);
			}
		},
		
		getResolutionWidth: function()
		{
			console.log("[huf.pal.getResolutionWidth]");
			if(window.HUFPALCORE){
				return window.HUFPALCORE.getResolutionWidth();
			}
		},
		
		getResolutionHeight: function()
		{
			console.log("[huf.pal.getResolutionHeight]");
			if(window.HUFPALCORE){
				return window.HUFPALCORE.getResolutionHeight();
			}
		},
		
		getDeviceModelName: function()
		{
			if(window.HUFPALCORE){
				return window.HUFPALCORE.getDeviceModelName();
			}
		},
		
		popupAlert: function(strTitle, strMessage, strBtnMessage, cbBtnCallback)
		{
			if(window.HUFPALCORE){
				return window.HUFPALCORE.alertDialog(strTitle, strMessage, strBtnMessage, cbBtnCallback);
			}
		},
		
		playAudio: function(url)
		{
			if(window.HUFPALCORE)
				window.HUFPALCORE.playAudio(url);
			
			console.log("[huf.pal.playAudio] url:"+url);			
		},
		
		playVideo: function(url)
		{
			if(window.HUFPALCORE)
				window.HUFPALCORE.playVideo(url);
				
			console.log("[huf.pal.playVideo] url:"+url);			
		},
		
		playPhoto: function(url)
		{
			if(window.HUFPALCORE)
				window.HUFPALCORE.playPhoto(url);
				
			console.log("[huf.pal.playPhoto] url:"+url);
		},
		
		browseURL: function(url)
		{
			if(window.HUFPALCORE)
				window.HUFPALCORE.browseURL(url);
				
			console.log("[huf.pal.browseURL] url:"+url);
		},	
		
		popHostActivity: function()
		{
			if(window.HUFPALCORE)
				window.HUFPALCORE.popHostActivity();
				
			console.log("[huf.pal.popHostActivity]");
		},

		getWidth: function()
		{
			var width = 0;
			if (window.HUFPALCORE)
				width = window.HUFPALCORE.getWidth();
				
			console.log("[huf.pal.getWidth]");
			return width;
		},

		getHeight: function()
		{
			var height = 0;
			if (window.HUFPALCORE)
				height = window.HUFPALCORE.getHeight();

			console.log("[huf.pal.getHeight]");
			return height;
		},
		
		getAppCapability: function()
		{
			var nAppCapability = 0;
			if (window.HUFPALCORE)
			{
				nAppCapability = window.HUFPALCORE.getAppCapability();
			}

			console.log("[huf.pal.getAppCapability]");
			return nAppCapability;
		},
		
		// called by native layer, response need to be escaped!
		_httpCallback: function(id,status_code,escaped_response)
		{
			console.log("[huf.pal._httpCallback] id:"+id+" status:"+status_code);
			if(this._httpCallbackMap)
			{
				var func = this._httpCallbackMap.get(id);
				if(func)
				{
					func(status_code,unescape(escaped_response));
					this._httpCallbackMap.unset(id);
				}
				else
					console.log("[huf.pal._httpCallback] callback not found!");
			}
			else
				console.log("[huf.pal._httpCallback] httpCalbackMap is not created!");			
		},

		onDlgCallback: function(name) {
	        console.log("huf.pal.onDlgCallback: " + name);
	        if (this._onDlgCallbackMap) {
	            this._onDlgCallbackMap.each( function(pair) {
	                pair.value(name); // cbFunc = pair.value;
	            });
	        }
		},
		
		onDisconnectCallback: function(){
			console.log("huf.pal.onDisconnectCallback:");
			spark.globalUIObject.nFailedCount = 0;
			huf.navigator.popViewsTo("Scanning");
			huf.navigator.refreshScanning();
		},
			
		popUpKeyboard: function(caption,description,isWarning,value,strOk,strCancel) {
			console.log("huf.pal.popUpKeyboard:");
	        if (window.HUFPALCORE) {
	            return window.HUFPALCORE.showNativeDialog(caption, description, isWarning, value, strOk, strCancel);
	        }
	    },
	    
		regDlgSendCallback: function(uniqueID, callbackFunc) {
	        console.log("huf.pal.regDlgSendCallback: uniqueID = " + uniqueID);
	        if (!this._onDlgCallbackMap) {
	            this._onDlgCallbackMap = new Hash();
	        }
	        this._onDlgCallbackMap.set(uniqueID, callbackFunc);
	    },
		
	    unregDlgSendCallback: function(uniqueID) {
	        console.log("huf.pal.unregDlgSendCallback: uniqueID = " + uniqueID);
	        if (this._onDlgCallbackMap) {
	            this._onDlgCallbackMap.unset(uniqueID);
	        }
	    },		
		onDlgCancelCallback: function(name) {
	        console.log("huf.pal.onDlgCancelCallback: " + name);
	        if (this._onDlgCancelCallbackMap) {
	            this._onDlgCancelCallbackMap.each( function(pair) {
	                pair.value(name); // cbFunc = pair.value;
	            });
	        }
	    },
	    regDlgQuitCallback: function(uniqueID, callbackFunc) {
	        console.log("huf.pal.regDlgQuitCallback: uniqueID = " + uniqueID);
	        if (!this._onDlgCancelCallbackMap) {
	            this._onDlgCancelCallbackMap = new Hash();
	        }
	        this._onDlgCancelCallbackMap.set(uniqueID, callbackFunc);
	    },
	    unregDlgQuitCallback: function(uniqueID) {
	        console.log("huf.pal.unregDlgQuitCallback: uniqueID = " + uniqueID);
	        if (this._onDlgCancelCallbackMap) {
	            this._onDlgCancelCallbackMap.unset(uniqueID);
	        }
	    },
		sendXmlHttpRequest: function(url, method, postContentType, postBody, jsonHeaders, onComplete)
		{
			console.log("[huf.pal.sendXmlHttpRequest] "+method+" "+url);
			
			if(!this._httpCallbackMap) this._httpCallbackMap = new Hash();
			if(!this._reqsno) this._reqsno=0;
			
			var curReqID = ++this._reqsno;
			console.log("[huf.pal.sendXmlHttpRequest] reqID:"+ curReqID);
			this._httpCallbackMap.set(curReqID,onComplete);
			
			if(!method) method="get";
			if(!postContentType) postContentType="";
			if(!postBody) postBody="";
			if(!jsonHeaders) jsonHeaders="";
			
			if(window.HUFPALCORE)
				window.HUFPALCORE.sendXmlHttpRequest(curReqID,url,method,postContentType,postBody,jsonHeaders);
		},
		
		httpCommand : function(url, httpCommandCallback)
		{
			// set callback function
			huf.pal._httpCommandCallback = httpCommandCallback;
			
			console.log("[huf.httpCommand]"+url);
			if(window.HUFPALCORE){
				// execute http request and return http status code
				window.HUFPALCORE.httpCommand(url);
			}
		},
		
		httpCommandCallback: function(statusCode)
		{
			if (huf.pal._httpCommandCallback)
				huf.pal._httpCommandCallback(statusCode);
		},
		
		// PAL object UPnPDiscovery			
		UPnPDiscovery: 
		{			
			_stateDiscovery: false,
			_callbackAddSSDPRsp: null,
			_callbackRemoveSSDPRsp: null,
			//_callbackAddService: null,
			//_callbackRemoveService: null,
			
			setCallback: function(cbAddSSDPRsp, cbRemoveSSDPRsp)
			{
				huf.pal.UPnPDiscovery._callbackAddSSDPRsp=cbAddSSDPRsp;
				huf.pal.UPnPDiscovery._callbackRemoveSSDPRsp=cbRemoveSSDPRsp;

			},
			startUPnPDiscovery: function(MX, ST)
			{
								
				if (window.HUFPALSSDPCLIENT) {
					window.HUFPALSSDPCLIENT.start(MX, ST);
					huf.pal.UPnPDiscovery._stateDiscovery = true;
					console.log("[huf.pal.UPnPDiscovery.startUPnPDiscovery] MX="+MX+",ST="+ST);
				}
				else
					console.log("[huf.pal.UPnPDiscovery.startUPnPDiscovery] plugin not found!");	
				                                      
			},
			stopUPnPDiscovery: function()
			{
					
				if (window.HUFPALSSDPCLIENT) {
					window.HUFPALSSDPCLIENT.stop();
					huf.pal.UPnPDiscovery._stateDiscovery = false;
					console.log("[huf.pal.UPnPDiscovery.stopUPnPDiscovery]");
				}
				else
					console.log("[huf.pal.UPnPDiscovery.stopUPnPDiscovery] plugin not found!");	
			},
			_onSSDPRspAdd: function(dev)
			{
				console.log("[huf.pal.UPnPDiscovery._onSSDPRspAdd] dev="+dev);
				//var obj=(Object.isString(dev)&&dev.isJSON())?dev.evalJSON():null;
				eval("var obj="+dev+";");
				console.log("[huf.pal.UPnPDiscovery._onSSDPRspAdd] obj="+obj);
				if(huf.pal.UPnPDiscovery._stateDiscovery && huf.pal.UPnPDiscovery._callbackAddSSDPRsp)
					huf.pal.UPnPDiscovery._callbackAddSSDPRsp.defer(obj);
					
			},
			/* callback format
			{"cache-control":"max-age=180",
			 "host":"239.255.255.250:1900",
			 "location":"http://10.10.10.1:5431/dyndev/uuid:0018-f8d7-fe4c00009adc",
			 "nt":"upnp:rootdevice",
			 "nts":"ssdp:alive",
			 "server":"LINUX/2.4 UPnP/1.0 BRCM400/1.0",
			 "usn":"uuid:0018-f8d7-fe4c00009adc::upnp:rootdevice"
			} */
			_onSSDPRspRemove: function(dev)
			{
				console.log("[huf.pal.UPnPDiscovery._onSSDPRspRemove] dev="+dev);
				//var obj=(Object.isString(dev)&&dev.isJSON())?dev.evalJSON():null;
				eval("var obj="+dev+";");
				if(huf.pal.UPnPDiscovery._stateDiscovery && huf.pal.UPnPDiscovery._callbackRemoveSSDPRsp)
					huf.pal.UPnPDiscovery._callbackRemoveSSDPRsp.defer(obj);
					
			},

		}, // UPnPDiscovery
		
		// PAL object MouseEvent	
		MouseEvent:
		{
				TYPE:
			{
			   INPUT_MOUSE:0,
			   INPUT_KEYBOARD:1,
			   INPUT_HARDWARE:2,
			},
		    //dwFlags http://msdn.microsoft.com/en-us/library/ms646260(VS.85).aspx
			DWFLAGS:
			{
				//The dx and dy parameters contain normalized absolute coordinates. If not set, those parameters contain relative data: the change in position since the last reported position. This flag can be set, or not set, regardless of what kind of mouse or mouse-like device, if any, is connected to the system. For further information about relative mouse motion, see the following Remarks section.
			
				MOUSEEVENTF_ABSOLUTE: 0x8000,
			
				//The left button is down.
				MOUSEEVENTF_LEFTDOWN: 0x0002,
			
				//The left button is up.
				MOUSEEVENTF_LEFTUP:0x0004,

				//The middle button is down.
				MOUSEEVENTF_MIDDLEDOWN:0x0020,

				//The middle button is up.
				MOUSEEVENTF_MIDDLEUP:0x0040,

				//Movement occurred.
				MOUSEEVENTF_MOVE:0x0001,

				//The right button is down.
				MOUSEEVENTF_RIGHTDOWN:0x0008,

				//The right button is up.
				MOUSEEVENTF_RIGHTUP:0x0010,
			
				//The wheel has been moved, if the mouse has a wheel. The amount of movement is specified in dwData
				MOUSEEVENTF_WHEEL:0x0800,

				//An X button was pressed.
				MOUSEEVENTF_XDOWN:0x0080,

				//An X button was released.
				MOUSEEVENTF_XUP:0x0100,
			},
			
			sendMouseEvent: function(ip,port,type,auth_id,dx,dy,mouse_data,dwFlags,time)
			{
				//console.log("[huf.pal.MouseEvent.sendMouseEvent] arguments="+$A(arguments).toJSON());
				if(window.HUFPALUDPREQUESTSENDER)
					window.HUFPALUDPREQUESTSENDER.sendRemoteCommand(   ip,
				                                      port,
													  type,
													  auth_id,
													  dx,
													  dy,
													  mouse_data,
													  dwFlags,
													  time);
						
				
			},
			
			sendMouseEventV2: function(ip, port, tag, length, token, type, dx, dy, mouse_data, dwFlags, time)
			{
				//console.log("[huf.pal.MouseEvent.sendMouseEvent] arguments="+$A(arguments).toJSON());
				if(window.HUFPALUDPREQUESTSENDER)
					window.HUFPALUDPREQUESTSENDER.sendRemoteCommandV2(   ip,
				                                      port,
													  tag,
													  length,
													  token,
													  type,
													  dx,
													  dy,
													  mouse_data,
													  dwFlags,
													  time);
						
				
			},
			
			// let sysSpark update ip & port 
			setUDPIpPort: function(ip, port)
			{
				if(window.HUFPALUDPREQUESTSENDER)
					window.HUFPALUDPREQUESTSENDER.updateIPPort(ip, port);
			},
		}, // MouseEvent
		
		// PAL object MediaShareKernel			
		MediaShareKernel: 
		{
			startService: function(uuid, friendlyName)
			{
								
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.startUpnpService(uuid, friendlyName);
					console.log("[huf.pal.MediaShareKernel.startService] service started ...");
					
				}
				else
					console.log("[huf.pal.MediaShareKernel.startService] plugin not found!");	
				                                      
			},
			stopService: function()
			{
					
				if (window.HUFPALMEDIASHAREKERNEL) {
					console.log("[huf.pal.MediaShareKernel.stopService] stopping");
					window.HUFPALMEDIASHAREKERNEL.stopUpnpService();
					console.log("[huf.pal.MediaShareKernel.stopService] stopped");
				}
				else
					console.log("[huf.pal.MediaShareKernel.stopService] plugin not found!");	
			},
			
			setToken: function(token, IPPort)
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.setToken(token, IPPort);
				}
			},
			
			setAPIVersion20: function(bAPI20)
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.setAPIVersion20(bAPI20);
				}
			},
			
			isStarted: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.isStarted();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.isStarted] plugin not found!");
					return false;
				}

			},
			
			getPrimaryAddress: function()
			{

				if (window.HUFPALMEDIASHAREKERNEL) {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] getting primary addr");
					return window.HUFPALMEDIASHAREKERNEL.getPrimaryAddress();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return false;
				}
			},
			
			shareImageLibrary: function(share)
			{

				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.shareImageLibrary(share);
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
				}
			},
			
			isImageLibraryShared: function()
			{

				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.isImageLibraryShared();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return false;
				}
			},
			
			shareVideoLibrary: function(share)
			{

				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.shareVideoLibrary(share);
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
				}
			},
			
			isVideoLibraryShared: function()
			{

				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.isVideoLibraryShared();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return false;
				}
			},
			
			enableAccessControl: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.enableAccessControl();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
				}
			},
			
			disableAccessControl: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.disableAccessControl();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
				}
			},
			
			setAccessControlKey: function(key)
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					window.HUFPALMEDIASHAREKERNEL.setAccessControlKey(key);
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
				}
				
			},
			
			getAccessControlKey: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.getAccessControlKey();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return "";
				}
			},
			
			getAccessControlStatus: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.getAccessControlStatus();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return false;
				}
			},
			
			getLocation: function()
			{
				if (window.HUFPALMEDIASHAREKERNEL) {
					return window.HUFPALMEDIASHAREKERNEL.getLocation();
				}
				else {
					console.log("[huf.pal.MediaShareKernel.getPrimaryIp] plugin not found!");
					return false;
				}
			}
			
		},
		
		// PAL object KeyboardPlug			
		KeyboardPlug: 
		{
			_key: null,
			
			enableKeyboard: function(arg)
			{
				if(window.HUFPALKEYBOARDPLUG)
					window.HUFPALKEYBOARDPLUG.enableKeyboard(arg);
			
				console.log("[huf.pal.enableKeyboard");
			},
			
			disableKeyboard: function()
			{
				if(window.HUFPALKEYBOARDPLUG)
					window.HUFPALKEYBOARDPLUG.disableKeyboard();
			
				console.log("[huf.pal.disableKeyboard");
			},
			
			inputPassword: function(arg)
			{
				_key = arg;
				
				console.log("[huf.pal.KeyboardPlug.inputPassword] Key id:" + arg);
			},
			
			confirmPassword: function(arg)
			{
				if (_key == arg) {
					huf.pal.MediaShareKernel.setAccessControlKey(_key);
				}
				
				console.log("[huf.pal.KeyboardPlug.confirmPassword] Key id:" + arg);
			},
		},
		
		_setup: function(){}	
	};
	huf.pal._setup();
	
	// used to detect 2 fingers gesture
	huf.gesture =
	{
		// supported gesture events 
		_gestureEvents: ["gesturestart","gesturechange","gestureend"],
		_targets: [],// used to store which elements need to oberve...
		
		observe: function(element_id,event_name,handler)
		{
			console.log("[huf.gesture.observe] element:" + element_id + ", event:" + event_name);
			var element=$(element_id);
			if (element && huf.gesture._gestureEvents.include(event_name)) {				
				element._gesturehandler = function(e) {
					Object.extend(e,e.memo); // due to using Prototype fire(), custom event attributes will be copied to memo
					handler(e);
				};
				element.observe("huf:"+event_name,element._gesturehandler);
					
				if(!huf.gesture._targets.include(element)) 
					huf.gesture._targets.push(element);
			}
			else
				console.log("[huf.gesture.observe] Invalid Arguments!");
		},		
		// this method is provided to native as a callback
		_onGesture: function(args/*event_name,scale,rotation*/)
		{
			var event_name = args[0];
			var LParam = args[1];
			var RParam = args[2];
			console.log("[huf.gesture._onGesture] event:" + event_name + ", scale:" + LParam + ", rotation:" + RParam);
			
			// current native cannot confirm which webview element triggerred the gesture, so call all
			huf.gesture._targets.each(function(element)
			{				
				element.fire("huf:" + event_name,{"LParam":LParam, "RParam":RParam});
			});
		},		
		stopObserving: function(element_id,event_name,handler)
		{
			console.log("[huf.gesture.stopObserving] element:" + element_id + ", event:" + event_name);
			
			var element=$(element_id);
			if (element && huf.gesture._gestureEvents.include(event_name)) {
				element.stopObserving("huf:"+event_name,element._gesturehandler);		
				huf.gesture._targets = huf.gesture._targets.without(element);
			}					
		}
	};
	
	// define navigator object
	huf.navigator = 
	{
		_idprefix:	"hufview-",
		_stackView: [], // keep a view-element array as the stack for navigation
		
		// push a specified view into view stack		
		pushView: function(view_name, controller_ctor, arg_obj)
		{
			console.log("[huf.navigator.pushView] view_name:" + view_name);
			//console.log("[huf.navigator.pushView] ctor:" + (controller_ctor?controller_ctor.toString():"null"));
			//console.log("[huf.navigator.pushView] arg_obj:" + (arg_obj?Object.toJSON(arg_obj):"null"));
			
			// 1. hide current top view (div)			
			var topview = huf.navigator._stackView.last();
			if (topview) {
				if(topview.controller && topview.controller.deactivate)
					topview.controller.deactivate();
				//topview.hide();				
				console.log("[huf.navigator.pushView] hide previous view:" + topview.view);
			}
			
			// 2. render new view
			{
				/// Multi-language support
				var language = huf.pal.querySystemLanguage();
				var viewfilepath = "file:///android_asset/" + language + "/views/" + view_name + "-scene.html";
//				var viewfilepath = "file:" + language + "/views/" + view_name + "-scene.html";

				var viewhtml = null;
				var request = new Ajax.Request(
					viewfilepath, 
					{ // option
						method: 'get',
						asynchronous: false,
						evalJS: false,
						onSuccess: function(transport){
							viewhtml = transport.responseText;
						}
					}
				);
				console.log("view_template:\n"+viewhtml);
				
				var newview = new Element('div', { 'class': 'hufviewin' });				
				Element.insert(newview,viewhtml);
				Element.insert($('document-body'),{top:newview});					
								
				// setup controller for new pushed view
				if (controller_ctor) {
					newview.controller = new controller_ctor(arg_obj);
					
					if(newview.controller.setup)
						newview.controller.setup();
						
					if(newview.controller.activate)
						newview.controller.activate();
				}
				
				newview.id = huf.navigator._idprefix + view_name;
				newview.view = view_name;
				huf.navigator._stackView.push(newview);
				
				function StartTransit(oldview, newview){
					newview.style.left="auto";
					//newview.style.opacity="1.0";
					
					function EndTransit(oldview, newview){
						newview.className = "hufview";
						if(oldview)	oldview.hide();				
					};					
					
					EndTransit.delay(0.3,oldview, newview);				
				}				
				StartTransit.defer(topview, newview);				
			}
			
			console.log("stackView:"+huf.navigator._stackView.toJSON());
		},
		
		// called to remove top view from view stack
		popView: function()
		{
			console.log("[huf.navigator.popView]");
			
			var popview = huf.navigator._stackView.pop();
			if(popview)
			{
				// inform popped view controller
				if (popview.controller){
					if(popview.controller.deactivate)	popview.controller.deactivate();
					if(popview.controller.cleanup)		popview.controller.cleanup();
					delete popview.controller;
				}
					
				// remove popped view from DOM to update html rendering
				//popview.remove();
				popview.className = "hufviewout";
				
				// find the top
				var newtopview = huf.navigator._stackView.last();
				if (newtopview) {					
					if (newtopview.controller && newtopview.controller.activate) 
						newtopview.controller.activate();
					newtopview.show();
				}
				
				function StartTransit(popview){
					//popview.style.opacity="0";
					popview.style.left="100%";
					
					function EndTransit(popview){						
						popview.remove();				
					};					
					
					EndTransit.delay(0.3,popview);				
				}				
				StartTransit.defer(popview);		
			}	
			
			console.log("stackView:"+huf.navigator._stackView.toJSON());				
		},
		
		updateView: function()
		{
			console.log("[Remote2.0] updateView");
			var topview = huf.navigator._stackView.last();
			if (topview) 
			{
				if (topview.controller && topview.controller.update) 
				{
					topview.controller.update();
					console.log("[Remote2.0] updateView Done");
				}
			}
		},
		
		refreshScanning: function()
		{
			console.log("[huf.navigator.refreshView]");
			
			huf.navigator.popView();
			huf.navigator.pushView("Scanning", ScanningAssistant);
		},
		
		popViewsTo: function(view_name)
		{
			console.log("[huf.navigator.popViewsTo] target_view:" + view_name);
						
			var poplist = [];
			var target = null;
			
			var target_index = huf.navigator._stackView.indexOf($(huf.navigator._idprefix+view_name));
			if(target_index>=0) //found
			{
				var splice_num = huf.navigator._stackView.length-target_index;
				
				poplist = huf.navigator._stackView.splice(target_index+1,splice_num-1);
				target = huf.navigator._stackView.last();				
				
				poplist.each(function(item)
				{
					if (item.controller) {
						if (item.controller.deactivate) 
							item.controller.deactivate();
						if (item.controller.cleanup) 
							item.controller.cleanup();
						delete item.controller;
					}
					item.remove();
					//console.log("[huf.navigator.popViewsTo] remove:"+item.view);
				});
				
				if (target)
				{					
					if (target.controller && target.controller.activate)
					{
						target.controller.activate();
					}
				}
				target.show();
				poplist.clear();
				
				console.log("stackView:"+huf.navigator._stackView.toJSON());
			}			
		} // popViewsTo
	} // huf.navigator

	
	// define preferences manager object
	huf.preferencesManager = 
	{
		savePreferences: function()
		{
			console.log("[huf.preferencesManager.savePreferences]");
			if(window.HUFPALPREFERENCESMANAGER){
				return window.HUFPALPREFERENCESMANAGER.savePreferences();
			}
		},
		
		setPreferencesBoolean: function(key, preference)
		{
			console.log("[huf.preferencesManager.setPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER){
				return window.HUFPALPREFERENCESMANAGER.setPreferencesBoolean(key, preference);
			}
		},
		
		getPreferencesBoolean: function(key, defaultValue)
		{
			console.log("[huf.preferencesManager.getPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER){
				return window.HUFPALPREFERENCESMANAGER.getPreferencesBoolean(key, defaultValue);
			}
		},
		
		setPreferencesString: function(key, preference)
		{
			console.log("[huf.preferencesManager.setPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER){
				return window.HUFPALPREFERENCESMANAGER.setPreferencesString(key, preference);
			}
		},
		
		getPreferencesString: function(key, defaultValue)
		{
			console.log("[huf.preferencesManager.getPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER){
				return window.HUFPALPREFERENCESMANAGER.getPreferencesString(key, defaultValue);
			}
		},
		
		setTargetPreferencesBoolean: function(file, key, preference)
		{
			console.log("[huf.preferencesManager.setTargetPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER)
			{
				return window.HUFPALPREFERENCESMANAGER.setTargetPreferencesBoolean(file, key, preference);
			}
		},
		
		getTargetPreferencesBoolean: function(file, key, defaultValue)
		{
			console.log("[huf.preferencesManager.getTargetPreferencesBoolean]");
			if(window.HUFPALPREFERENCESMANAGER)
			{
				return window.HUFPALPREFERENCESMANAGER.getTargetPreferencesBoolean(file, key, defaultValue);
			}
		},
		
		setTargetPreferencesString: function(file, key, preference)
		{
			console.log("[huf.preferencesManager.setTargetPreferencesString]");
			if(window.HUFPALPREFERENCESMANAGER)
			{
				return window.HUFPALPREFERENCESMANAGER.setTargetPreferencesString(file, key, preference);
			}
		},
		
		getTargetPreferencesString: function(file, key, defaultValue)
		{
			console.log("[huf.preferencesManager.getTargetPreferencesString]");
			if(window.HUFPALPREFERENCESMANAGER)
			{
				return window.HUFPALPREFERENCESMANAGER.getTargetPreferencesString(file, key, defaultValue);
			}
		}
	} // huf.preferencesManager
	
	
	// after setup complete, invoke user's main()
	onLoad = function(){
		//
		// NOTE: We may get wrong width and height from window.innerWidth and window.innerHeight
		//       So, please get width and height from huf instead.
		//
		console.log("onLoad() width = " + huf.pal.getWidth() + ", height = " + huf.pal.getHeight());
		window.main();
	}
	window.onload = onLoad; 
	
} // with(window)
