﻿
function PasswordChange(data) {
	/* this is the creator function for your scene assistant object. It will be passed all the
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
	  console.log("PasswordChange");
}


PasswordChange.prototype.setup = function(){
	
	//-------------------------------------------------------------------------------------------
	//--------- Password ------------------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.UIPasswordObject = [$("password_1"), $("password_2"), $("password_3"), $("password_4")];
	this.passwordManager = {
		UIPasswordObject : this.UIPasswordObject,
		passwordLength : this.UIPasswordObject.length,
		password : [],
		
		inputPassword: function(value){
			this.password.push(value);
			this.updateUIPasswordObject();
			if (this.password.length == this.passwordLength){
				// pass the password to spark.globalUIObject
				spark.globalUIObject.password = "";
				for (var i = 0; i < this.password.length; i++){
					spark.globalUIObject.password += this.password[i];
				}
				
				var uuidOffset = spark.globalUIObject.currentDevice.usn.indexOf("::");
				if (uuidOffset < 0) 
				{
					uuidOffset = 42;  //uuid:bd40ebb8-3a1f-3607-e3fa-6d494973714a
				}
				
				var uuidPC = spark.globalUIObject.currentDevice.usn.substring(5, uuidOffset);
				huf.preferencesManager.setTargetPreferencesString(uuidPC, "password", spark.globalUIObject.password);
				
				this.password.clear();
				
				if (spark.globalUIObject.apiVersion == 1.0)
				{
					huf.navigator.popView();
				}
				else
				{
					spark.globalUIObject.currentService.authentication();
				}
				console.log("inputPassword done");
			}
		},
		
		backPassword: function(){
			this.password.pop();
			this.updateUIPasswordObject();
		},
		
		updateUIPasswordObject: function()
		{
			var nHeight = huf.pal.getResolutionHeight();
			var nWidth = huf.pal.getResolutionWidth();
			if ((nHeight >= 924 && nHeight <= 1124 && nWidth == 600) || (nHeight == 600 && nWidth >= 924 && nWidth <= 1124)) {
				if (nHeight > nWidth){
					nHeight = 1024;
				}
				else{
					nWidth = 1024;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1380 && nWidth == 800) || (nHeight == 800 && nWidth >= 1180 && nWidth <= 1380)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			else if ((nHeight >= 1180 && nHeight <= 1280 && nWidth == 720) || (nHeight == 720 && nWidth >= 1180 && nWidth <= 1280)) {
				if (nHeight > nWidth){
					nHeight = 1280;
				}
				else{
					nWidth = 1280;
				}
			}
			var strResolution = "";
			if (nHeight > nWidth)
			{
				strResolution = "" + nHeight + "" + nWidth;
			}
			else 
			{
				strResolution = "" + nWidth + "" + nHeight;
			}
			for (var i = 0; i < this.passwordLength; i++)
			{
				if (this.password[i] != null)
					this.UIPasswordObject[i].src = "../Resource/" + strResolution + "/images/password/code_square_frame_withdot.png";
				else
					this.UIPasswordObject[i].src = "../Resource/" + strResolution + "/images/password/code_square_frame.png";
			}
		}
	}
	//-------------------------------------------------------------------------------------------
	//-------- Keyboard buttons -----------------------------------------------------------------
	//-------------------------------------------------------------------------------------------
	this.keyboardFunctions = {
		keyboardBtnClicked: function(e){
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			var value = data[1];
			switch (oper) {
				case "number":
					var strUIElementName = "keyboardButton_" + value;
					var strReleaseImagePath = "../Resource/800480/images/password/Keyboard/"  + value + "_p.png";
					$(strUIElementName).src = strReleaseImagePath;
					this.passwordManager.inputPassword(value);
					break;
				case "space":
					break;
				case "back":
					var strUIElementName = "keyboardButton_" + oper;
					var strReleaseImagePath = "../Resource/800480/images/password/Keyboard/"  + oper + "_p.png";
					$(strUIElementName).src = strReleaseImagePath;
					this.passwordManager.backPassword();
					break;
				case "popview":
					spark.globalUIObject.nFailedCount = 0;
					huf.navigator.popViewsTo("Scanning");
					break;
			}
			e.preventDefault();
		},
		keyboardBtnRelease: function(e){
			var data = $A(arguments);
			data.shift();
			var oper = data[0];
			var value = data[1];
			switch (oper) {
				case "number":
					var strUIElementName = "keyboardButton_" + value;
					var strReleaseImagePath = "../Resource/800480/images/password/Keyboard/"  + value + ".png";
					$(strUIElementName).src = strReleaseImagePath;
					break;
				case "back":
					var strUIElementName = "keyboardButton_" + oper;
					var strReleaseImagePath = "../Resource/800480/images/password/Keyboard/"  + oper + ".png";
					$(strUIElementName).src = strReleaseImagePath;
					break;
				case "popview":
					break;
			}
			e.preventDefault();
		}
	}
	
	Event.observe($("keyboardButton_1"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 1));
	Event.observe($("keyboardButton_2"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 2));
	Event.observe($("keyboardButton_3"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 3));
	Event.observe($("keyboardButton_4"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 4));
	Event.observe($("keyboardButton_5"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 5));
	Event.observe($("keyboardButton_6"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 6));
	Event.observe($("keyboardButton_7"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 7));
	Event.observe($("keyboardButton_8"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 8));
	Event.observe($("keyboardButton_9"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 9));
	Event.observe($("keyboardButton_0"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'number', 0));
	Event.observe($("keyboardButton_space"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'space'));
	Event.observe($("keyboardButton_back"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'back'));
	Event.observe($("password-backBtn"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked.bindAsEventListener(this, 'popview'));
	Event.observe($("keyboardButton_1"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 1));
	Event.observe($("keyboardButton_2"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 2));
	Event.observe($("keyboardButton_3"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 3));
	Event.observe($("keyboardButton_4"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 4));
	Event.observe($("keyboardButton_5"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 5));
	Event.observe($("keyboardButton_6"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 6));
	Event.observe($("keyboardButton_7"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 7));
	Event.observe($("keyboardButton_8"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 8));
	Event.observe($("keyboardButton_9"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 9));
	Event.observe($("keyboardButton_0"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'number', 0));
	Event.observe($("keyboardButton_back"), viewUtil.clickUpEventName(), this.keyboardFunctions.keyboardBtnRelease.bindAsEventListener(this, 'back'));
}

PasswordChange.prototype.update = function(){
	console.log("[Remote2.0] PWD change update begin");
	spark.globalUIObject.password= "";
	this.passwordManager.updateUIPasswordObject();
	console.log("[Remote2.0] PWD change done");
},


PasswordChange.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */

};

PasswordChange.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

PasswordChange.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
	Event.stopObserving($("keyboardButton_1"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_2"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_3"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_4"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_5"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_6"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_7"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_8"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_9"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_0"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_space"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("keyboardButton_back"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
	Event.stopObserving($("password-backBtn"), viewUtil.clickEventName(), this.keyboardFunctions.keyboardBtnClicked);
};
